      program idealf
c finds energy for ideal fermions also s(k), rhos, nk and hartree-fock
      parameter (ndim=3,mnp=33,nx=20,nx2=2*nx+1)
      parameter (nsites=nx2**ndim,kmax=100,mnr=1000,dr=.1)
      real*8 ea,es,esq,eava,eg,error
      dimension icount(nsites),k(ndim,mnp),boltz(nsites),ee(nsites)
     +,knew(ndim),k2num(0:kmax),sofk(0:kmax),kocc(0:kmax),g(mnr)
      indx(ix,iy,iz)=ix+nx+1+nx2*(iy+nx+nx2*(iz+nx))

      write (*,*)' input seed'
      read (*,*) iseed
      yy=rand(iseed)
c this is density of spin up electrons.
      rho=.01635/2
      hbs2m=8.04177
!     rho=.119365
!     hbs2m=.5
      write (*,*) ' input np beta nstep '
      read (*,*) np,beta,nstep

      pi=3.1415926535
      vol=np/rho
      el=(vol)**(1./ndim)
      nr=1+.5*el/dr
c add to s(k) every ns`th pass
      ns=4
      tpil=(2*pi/el)**2
      f=hbs2m*tpil
      write (*,*) ' el f ',el,f

      do 7 i=1,kmax
      sofk(i)=0
      kocc(i)=0
7     k2num(i)=0

c set up boltz tables
      do 5 iz=-nx,nx
      do 5 iy=-nx,nx
      do 5 ix=-nx,nx
      ind=indx(ix,iy,iz)
      isq=ix**2+iy**2+iz**2
      if(isq.le.kmax)k2num(isq)=k2num(isq)+1
      e=f*isq
      ee(ind)=e
      ff=beta*e
      if(ff.lt.75.) then
         boltz(ind)=exp(-ff)
      else
          boltz(ind)=0.
      endif
5     continue

      do 44 i=1,nsites
44    icount(i)=0
c put particles down at random
      c=max(sqrt(6./(beta*f)),6.)
c     etotal=0.
      do 15 i=1,np

      do 10 l=1,ndim
      kd=c*(rand(0)-.5)
      if(kd.gt.nx) kd=kd-nx2
      if(kd.lt.-nx) kd=kd+nx2
10    k(l,i)=kd

      ind=indx(k(1,i),k(2,i),k(3,i))
      icount(ind)=icount(ind)+1
c     etotal=etotal+ee(ind)
15    continue
c     write (*,*) ' e0 ', etotal/np

      isofk=0
      momsq=0.
      ic=-nstep/ns
c     start the mc
      nbl=20
      do 100 ibl=0,nbl
      ea=0
c     eb=0

      do 200 istep=1,nstep
      do 210 i=1,np

c make a move
      iold=indx(k(1,i),k(2,i),k(3,i))
      eold=ee(iold) 
      do 220 l=1,ndim
      kd=ifix(3*rand(0))-1 + k(l,i)
      if(kd.gt.nx) kd=kd-nx2
      if(kd.lt.-nx) kd=kd+nx2
220   knew(l)=kd
      inew=indx(knew(1),knew(2),knew(3))

      if(icount(inew).gt.0) then
        prob=0.
        ea=ea+eold
      else
        de=ee(inew)-ee(iold)
        if(boltz(inew).gt.boltz(iold)) then
          prob=1.
        else
          prob=boltz(inew)/boltz(iold)
        endif
        ea=ea+eold+prob*de
      endif

c accept the move
      if(rand(0).lt.prob) then
       nacc=nacc+1
c      etotal=etotal+de
       icount(iold)=icount(iold)-1
       icount(inew)=icount(inew)+1
       do 230 l=1,ndim
230    k(l,i)=knew(l)
      endif
c     eb=eb+etotal
210   continue

c compute the structure factor
      ic=ic+1
      if(ic.ge.ns) then
      ic=0
      isofk=isofk+1
      do 310 i=2,np
      do 310 j=1,i-1
      k2=0
      do 320 l=1,ndim
320   k2=k2+(k(l,i)-k(l,j))**2
      if(k2.le.kmax)sofk(k2)=sofk(k2)+1
310   continue
c also superfluidity
      do 360 l=1,ndim
      mom=0
      do 361 i=1,np
361   mom=mom+k(l,i)
360   momsq=momsq+mom**2
c also occupation numbers
      do 330 i=1,np
      k2=0
      do 332 l=1,ndim
332   k2=k2+k(l,i)**2
      if(k2.le.kmax)kocc(k2)=kocc(k2)+1
330   continue
      endif

200   continue

      eava=ea/(nstep*np)
c     eavb=eb/(nstep*np**2)
      es=es+eava
      esq=esq+eava**2
      if(ibl.gt.1) then
           eg=es/ibl
           error=sqrt((esq/ibl-eg**2)/(ibl-1))
           write (*,*) eava,eg,error
      endif

      if(ibl.eq.0) then
        es=0
        esq=0
      endif

c check for double countings
      do 400 i=1,nsites
400   if(icount(i).gt.1.or.icount(i).lt.0) stop
c     write (*,*) ((k(l,i),l=1,ndim),i=1,np)

100   continue
      write (*,*) ' final kinetic energy=',eg,' error=',error
      write (*,*) 'acc rat=',nacc/float(nstep*np*(nbl+1))
      write (*,*)'      k    wt      s(k)      n(k) '

      stop
      if(ndim.eq.3)vmad=-2.837297479/el
      if(ndim.eq.2)vmad=-3.90026492/el
      coul=.5*vmad
      const=(ndim-1)*pi/vol

      do 600 k2=0,kmax
      if(k2num(k2).gt.0) then
       sofk(k2)= 1-2.*sofk(k2)/float(np*k2num(k2)*isofk)
       write (*,1) sqrt(tpil*k2),k2num(k2),sofk(k2)
     +, float(kocc(k2))/float(k2num(k2)*isofk)
       if(k2.gt.0)coul=coul+const*k2num(k2)
     &              *(sofk(k2)-1.)/sqrt(tpil*k2)**(ndim-1)
      endif
600   continue
      write (*,*)' Coulomb energy=',coul, ' total=', coul+eg
1     format(f10.3,i5,2f12.6)
      rhon=(2*beta*hbs2m*tpil*momsq)/float(np*ndim*isofk)
      rhos=1-rhon
      write (*,*)' rhon rhos ',rhon,rhos
c now compute g(r)
      do 650 i=1,nr
      r=dr*i
      g(i)=1.-1./np
      do 655 k2=1,kmax
      if(k2num(k2).gt.0) then
        arg=r*sqrt(tpil*k2)
        g(i)=g(i)+sin(arg)*k2num(k2)*(sofk(k2)-1.)/(np*arg)
      endif
655   continue
650   continue
      open(30,file='ideal.gr')
      write (30,*)'RANK 1 ',nr
      write (30,*)' GRID 1 LINEAR ',dr,' ',r
      write (30,*)' BEGIN g(r)'
      write (30,2) (g(i),i=1,nr)
      write (30,2) (.1,i=1,nr)
2     format(5f10.4)
      stop
      end
