      program nsclook
c generates error bars time histories using 
c plus error estimates and histograms
c    
c D. Ceperley 3/2/94
      implicit real*8 (a-h,o-z)
      implicit integer (i-n)
      parameter (mncs=300,mnsc=60)
      dimension data(2,mncs,mnsc),idim(3),work(mncs,3),ics(mnsc)
      character name*(14),qaname(mnsc)*8,units(mnsc)*8
      logical ifex

41    write (*,*) ' input run id?'
      read (*,2) name
2     format(a14)
        ln=index(name,' ')-1
      name=name(1:ln)//'.sc'
      ln=ln+5
c does this file exist?
        inquire(file=name(1:ln),exist=ifex)
        if(ifex) go to 40
         write (*,*)' file does not exist '
         go to 41
40    open(1,file=name)
      idim(1)=-mnsc
      idim(2)=4
      idim(3)=0
      call checkrnk(1,3,idim)
      write (*,*)' number of scalars found:',idim(1)
      call findbegn(1)
      write (*,*)' number of configs to throw away at beginning?'
      read (*,*) nskip
      l=1
      do 100 k=1,10000
c note we transpose the data
      read (1,*,end=3) (data(1,l,i),i=1,idim(1))
      read (1,*,end=3) (data(2,l,i),i=1,idim(1))
      read (1,91,end=3) (qaname(i),i=1,idim(1))
      read (1,91,end=3) (units(i),i=1,idim(1))
91    format(6a8)
92    format(6e18.10)
90    continue
      if(k.gt.nskip) l=l+1
      if(l.gt.mncs) go to 3
100   continue
3     ncs=l-1
      close(1)
      write (*,*)' number of configurations found:',ncs
      call mcanal(data,idim(1),ncs,mncs,work,qaname,name,units)
      ncolm=0
300   write (*,*)' data to dump to graphics file? 0 to stop'
      read (*,*) icolm
      if(icolm.le.0.or.icolm.gt.idim(1)) go to 310
       ncolm=ncolm+1
       ics(ncolm)=icolm
      go to 300

310   if(ncolm.gt.0) then
      do l=1,ncs
      write (10,99)
     +(data(1,l,ics(icolm))/data(2,l,ics(icolm)),icolm=1,ncolm)
99      format(10e12.5)
      enddo
      endif
      stop 
      end

      subroutine mcanal(a,n,ncs,mncs,work,qaname,name,units)
      implicit real*8 (a-h,o-z)
      real*8 a(2,mncs,n),work(mncs,3)
      character qaname(n)*(*),name*14,temp2*15,units(n)*(*)
      tau=2.

      do i=1,n

c loop over scalars and find if any are zero
      bot=abs(a(2,1,i))
      top=abs(a(1,1,i))
      sb=0.
      st=0.
      do 11 j=1,ncs
      sb=sb+a(2,j,i)
      st=st+a(1,j,i)
       top=max(abs(a(1,j,i)),top)
11     bot=min(abs(a(2,j,i)),bot)
      if(bot*top.gt.0.) then

c we will plot this scalar
       abar=st/sb
       var=0
       do j=1,ncs
       work(j,1)=a(1,j,i)/a(2,j,i)
       var=var+(work(j,1)-abar)**2
       enddo
       var=var/ncs
       error=sqrt(var/(ncs-1.))
      write (*,8) i,qaname(i),units(i),abar,error
8     format(i5,2a10,2e16.8)
c correlation function
      ncor=ncs/5
      call cf(work,ncs,work(1,2),abar,var,tau,ncor)

      call block(work,ncs,10)

      endif
      enddo
      return 
      end


      subroutine block(a,ncs,minblk)
      implicit real*8 (a-h,o-z)
c prints out error(blocksize) 
      real*8 a(ncs),errors(15)

      nblock=ncs
      do 300 kkk=1,100
c find mean and variance of current blocking
      abar=0.
      var =0.
      do 310 k=1,nblock
      abar=abar+a(k)
310   var=var+a(k)**2
      abar=abar/nblock
      errors(kkk)=sqrt((var/nblock-abar**2)/(nblock-1.))
      nblock=nblock/2

      if(nblock.lt.minblk) go to 100
      do 250 k=1,nblock
250   a(k)=.5*(a(2*k-1)+a(2*k))
300   continue
100   continue
      write (6,101) (errors(k),k=1,kkk)
101   format(10x,' blocked errors ',6e12.5)
      return
      end

      subroutine cf(a,ncs,corrf,abar,var,dt,ncor)
      implicit real*8 (a-h,o-z)
      real*8 a(ncs),corrf(ncor)
      ncor=min(ncor,ncs-1)
      do 100 i=1,ncor+1
100   corrf(i)=0
      do 200 i0=1,ncs-1
        do 300 i1=i0+1,min(ncs,i0+ncor)
300     corrf(i1-i0+1)=corrf(i1-i0+1)+(a(i0)-abar)*(a(i1)-abar)
200   continue
       tau=.5*dt
       do 400 i=1,ncor
       corrf(i+1)=corrf(i+1)/(var*(ncs-i))
400    tau=tau+dt*corrf(i+1)
       corrf(1)=1.
       write (*,*)'         kappa= ',tau
       return
       end

      subroutine histo(a,ncs,abar,var)
      implicit real*8 (a-h,o-z)
      parameter (nbins=100)
      dimension a(ncs),nhits(nbins),x(2*nbins),y(2*nbins)
c find max and min values
      aup=a(1)
      adn=a(1)
      do 1 i=2,ncs
      aup=max(a(i),aup)
1      adn=min(a(i),adn)
c     write (*,*)' min ',adn,' max ',aup
      da=1.00001*(aup-adn)/(nbins-1)
      dai=1./da
c find mean variance and histogram
      asum=0.
      asq=0.
      do 10 i=1,nbins
10    nhits(i)=0.
      do 20 i=1,ncs
      asum=asum+a(i)
      asq=asq+a(i)**2
      index=(a(i)-adn)*dai+1
      nhits(index)=nhits(index)+1
20    continue
      abar=asum/ncs
      var=asq/ncs-abar**2
      err=sqrt(var/(ncs-1))
c     write(*,*)' mean ',abar,' var ',var,' err ',err
      do 30 i=1,nbins
      x(2*i-1)=adn+(i-1)*da
      x(2*i)=adn+i*da
      y(2*i-1)=nhits(i)
30    y(2*i)=nhits(i)
c     call ezxy(y,x,2*nbins,'$')
      return
      end

      subroutine cross(a,b,ncs,marg)
      implicit real*8 (a-h,o-z)
      real*8 a(marg,ncs),b(marg,ncs)
c find the relative correlation coef between a and b
      asum=0.
      bsum=0.
      asq=0.
      bsq=0.
      ab=0.
      do 100 i=1,ncs
      asum=asum+a(1,i)
      asq=asq+a(1,i)**2
      bsum=bsum+b(1,i)
      bsq=bsq+b(1,i)**2
      ab=ab+a(1,i)*b(1,i)
100   continue
      abar=asum/ncs
      bbar=bsum/ncs
      avar=asq/ncs-abar**2
      bvar=bsq/ncs-bbar**2
      write (*,*)' mean of a and b ',abar,bbar
      write (*,*)' variance of a and b ',avar,bvar
      write (*,*)'relative variance of a and b ',avar/abar**2
     +   ,bvar/bbar**2
      write (*,*)' correlation of a and b',ab/ncs-abar*bbar
      write (*,*)'relative correlation of a and b',ab/(abar*bbar*ncs)-1.
      return
      end

      function trivial(a,n)
      implicit real*8 (a-h,o-z)
      real*8 a(1)
      trivial=a(1)
      n=1
      return
      end

      function ratio(a,n)
      implicit real*8 (a-h,o-z)
      dimension a(2)
      ratio=a(1)/a(2)
      n=2
      return
      end

      function difratio(a,n)
      implicit real*8 (a-h,o-z)
      real*8 a(4)
      difratio=a(1)/a(2)-a(3)/a(4)
      n=4
      return
      end
