      program pathplot5
c plots a path from a pc file with fourier smoothing.
      include '../mach.p'
      integer mnc,mnp,mnpw,mslices,ndim,mnpw4
      parameter (mnp=150,ndim=3,mslices=100,mnc=2)
      parameter (mnpw=1+mnp*ndim*mslices/mcpw,mnpw4=mcpw*mnpw)
      character qtime*26
      real*8 el2(3),hbs2mt(mnc),r(ndim,mnp,mslices),rperm(ndim,mnp)
     +,unwrap(ndim,mslices*mnp),dx(3),taut,qidt
     +,rnew(ndim,mslices*mnp),wrap
      integer ncompst(mnc),ipack(mnpw),ix(mnpw4),iperm(mnp)
     +,i,iflag,ios,irec,iref,irev,irp,j,join,k,l,ln,ic,lcycle(mnp)
     +,ndimt,npartst,nrec,nslicest,ntypest,nwp,il,it,itype(mnp)
     +,ncycles(mnp),ndup,idx,idy,nk,idata,kk,jj,iwrap,itime(mslices*mnp)
     +,idatan
      character name*(14)
      logical ifex

41    write (*,*) ' input run id?'
      read (*,2) name
2     format(a14)
        ln=index(name,' ')-1
      name=name(1:ln)//'.pc'
      ln=ln+3
c does this file exist?
        inquire(file=name(1:ln),exist=ifex)
        if(ifex) go to 40
         write (*,*)' file does not exist '
         go to 41
40    open(90,file=name,form='unformatted')

      write (*,*)' output name '
      read (*,2) name
      ln=index(name,' ')-1
c open output fileo
      open(92,file=name(1:ln)//'.pt')

1     nrec=0
      read (90,end=22,err=23,iostat=ios)
     + qidt,qtime,ndimt,npartst,nslicest,(el2(l),l=1,ndimt)
     +,ntypest,(ncompst(l),l=1,ntypest),(hbs2mt(l),l=1,ntypest),taut,nwp

      write (6,11) qidt,qtime
11    format(' reading packed files id=',a14,' ',a26)
c     write (92,9999) ndimt,nslicest,taut,npartst,(el2(l),l=1,ndimt)
9999   format(3f12.6)
      write (6,12) ndimt,npartst,nslicest,ntypest,taut
     +   ,(el2(l),l=1,ndim)
      write (6,*)' nwp=',nwp
      write (6,3) (ncompst(l),hbs2mt(l),l=1,ntypest)
12    format('  ndim nparts nslices ntypes el12',4i5,4e12.5)
3     format(' ncomps and hbs2m ',3(i5,e12.5))

      if(ndim.ne.ndimt)stop
c now read data and unpack it
      write (*,*)' which configuration ?'
      read (*,*) irp
      
      do 20 irec=1,irp
      read (90,end=22,err=23,iostat=ios)
     +join,iref,irev,(iperm(i),i=1,npartst),(ipack(i),i=1,nwp)
      nrec=nrec+1
20    continue
      
      call upack(r,mnp,ndimt,npartst,nslicest,el2,ipack,ix,nwp,mcpw)

      write (*,*) ' join iref irev =',join,iref,irev
      call cycles(iperm,npartst,lcycle,ncycles)

c define itype and rperm
         il=0
         it=1
         do i=1,npartst
         il=il+1
         if(il.gt.ncompst(it) ) then
            it=it+1
            il=0
         endif
         itype(i)=it
         do l=1,ndim
            rperm(l,iperm(i))=r(l,i,join)
         enddo
         enddo

      write (*,*) ' number of fourier components nk?'
      read (*,*) nk
      ndup=1 ! these are the number of copies to make!
c     write (*,*) (iperm(i),i=1,npartst)

c now loop over the particles and write them out
      do i=1,npartst
            do l=1,ndim
            unwrap(l,1)=rperm(l,i)
            enddo
            it=itype(i)
            ic=lcycle(i)
        idata=1
        k=i
c cycle length=il
        il=0
c new end point of permutation
30      j=iperm(k)
c have we visited j yet ?
        if(j.lt.0) go to 201
c no, update cycle length ...
        il=il+1
c ... and mark visit
        iperm(k)=-j

c add particle data to unwrap
            do jj=1,nslicest
            kk=join+jj
            if(kk.gt.nslicest) kk=kk-nslicest

            do l=1,ndim
              dx(l)=r(l,k,kk)-unwrap(l,idata)
               iwrap=(dx(l)+101*el2(l))/(2*el2(l))
               wrap=(iwrap-50)*el2(l)*2
               dx(l)=dx(l)-wrap
c now unwind the position
              unwrap(l,idata+1)=unwrap(l,idata)+dx(l)
            enddo
            idata=idata+1
            enddo

c next link
        k=j
        go to 30
201      continue
c found a cycle of length il
        if(il.gt.0) then
c do fourier smoothing?
           if(nk.gt.0) call fs(unwrap,idata-1,ndim,il*nk)
c now slice it up again
          idata=0
          idatan=0
          do kk=1,il

           do l=1,ndim
               iwrap=(unwrap(l,idata+1)+101*el2(l))/(2*el2(l))
               dx(l)=(iwrap-50)*el2(l)*2
           enddo

          do j=1,nslicest
            idata=idata+1
            idatan=idatan+1
            itime(idatan)=j
            do l=1,ndim
              rnew(l,idatan)=unwrap(l,idata)-dx(l)
            enddo
          enddo

c now add two points at the end
          do l=1,ndim
            rnew(l,idatan+1)=unwrap(l,idata+1)-dx(l)
            rnew(l,idatan+2)=unwrap(l,idata+1)-dx(l)
          enddo
             itime(idatan+1)=nslicest+1
             itime(idatan+2)=0
             idatan=idatan+2

          enddo

c write out coordinates expanded
         write (*,*) il,i,idata,idatan
            do idx=1,ndup
            dx(1)=el2(1)*(-1-ndup+2*idx)
            do idy=1,ndup
            dx(2)=el2(2)*(-1-ndup+2*idy)

            do j=1,idatan
            write (92,992) i,itime(j),it,ic,(rnew(l,j)+dx(l),l=1,ndim) 
992   format(4i4,3f10.4)
            enddo

            enddo
            enddo
        endif

      enddo

      stop

22    write (6,13) nrec
13    format(' read and unpacked ',i10,' configurations ')
      rewind 90
      go to 1
23      write (6,14) irec,ios
14      format(' could not read record ',i10,' error no ',i10)
       if(irec.eq.1) iflag=-1
      stop
      end 

      subroutine cycles(iperm,nparts,lcycle,ncycles)
      integer iperm(nparts),lcycle(nparts),ncycles(nparts)
c     write (*,77) (iperm(i),i=1,nparts)
77    format(10i4)
      lcym=0
      do i=1,nparts
      ncycles(i)=0
      enddo

      do i=1,nparts
        k=i
c cycle length=il
        il=0
c new end point of permutation
30      j=iperm(k)
c have we visited j yet ?
        if(j.lt.0) go to 20
c no, update cycle length ...
        il=il+1
c ... and mark visit
        iperm(k)=-j
c next link
        k=j
        go to 30
20      continue
c found a cycle of length il
        lcym=max(lcym,il)
        if(il.gt.0) then
         ncycles(il)=ncycles(il)+1

c now store cycle length in lcycle
         k=i
35       j=-iperm(k)
         lcycle(j)=il
         if(j.eq.i) go to 25
         k=j
         go to 35
25       continue

        endif
       enddo
 

c undo visit-markers
       do i=1,nparts
          iperm(i)=-iperm(i)
       enddo
      write (*,77) (ncycles(i),i=1,lcym)
      write (*,77) (iperm(i),i=1,nparts)
 
      return
      end

      subroutine fs(unwrap,nslices,ndim,nk)
      parameter (ns=1000)
      real*8 unwrap(ndim,nslices+1),c(0:ns),s(0:ns)
      if(nk.gt.ns)stop
      tpim=2*3.1415926535/nslices
      do l=1,ndim
      dr=(unwrap(l,nslices+1)-unwrap(l,1))/nslices

       do k=0,nk
       c(k)=0
       s(k)=0
       enddo

       do i=1,nslices
       rr=(unwrap(l,i)-dr*(i-1))/nslices

       do k=0,nk
       arg=tpim*k*(i-1)
       c(k)=c(k)+rr*cos(arg)
       s(k)=s(k)+rr*sin(arg)
       enddo
       enddo

c now reconstruct
       do i=1,nslices
       unwrap(l,i)=c(0)+dr*(i-1)
         do k=1,nk
         arg=tpim*k*(i-1)
         unwrap(l,i)=unwrap(l,i)+2*(cos(arg)*c(k)+sin(arg)*s(k))
         enddo
       enddo
       unwrap(l,nslices+1)=unwrap(l,1)+dr*nslices
      enddo
      return
      end
