      program trace
      parameter(maver=40,mblocks=1000,msets=50,mn=20,mtrace=10)
      implicit real*8 (a-h,o-z)
      real*8 a(mblocks,maver),wt(mblocks,maver)
      character date*36,name(maver)*16,units(maver)*16
     .,p(mn)*16,filen*16
      integer first(msets),last(msets),itrace(mtrace)
     .  ,start,finish,ndata
      logical ifex

      call ofile(a,wt,name,units,naver,nsets,first,last
     .    ,mblocks,maver,msets,filen)

       write (1,*)' value  units           mean        cor-err        un  
     .cor-err  efficiency cor-time'

! default for averaging is last set
      start=first(nsets)
      finish=last(nsets)
      ndata=finish-start+1
      if(ndata.le.0)stop
      ! loop over averages and compute properties
      do i=1,naver
       call mean(ndata,a(start,i),wt(start,i),name(i),units(i))
      enddo

! if .rep file present do linear combination
      inquire(file='.report',exist=ifex)
      if(ifex) go to 20
      write (1,*)' file .report does not exist '
      go to 10
20    write (1,*)' derived averages '
      open(2,file='.report',form='formatted')
9     j=ipickoff(2,p,n,mn)
      if(j.eq.1) go to 10
       
      
        if(naver.eq.maver) then
          write (*,*)' maver too small ',maver
          stop
        endif
        do l=1,finish !create a new average in naver+1
         a(l,naver+1)=0.d0
         wt(l,naver+1)=1.d0
        enddo
        n2=n/2
        do i=2,n2
         cx=rlread(p(i*2-1))
         k=ifind(p(i*2),name,naver)
         if(k.le.0.or.k.gt.naver) then
               write (*,*)' symbol undefined ',p(1)
               go to 9 ! exit if symbol undefined
         endif
         do l=start,finish
          a(l,naver+1)=a(l,naver+1)+cx*a(l,k)
          if(wt(l,k).eq.0.d0) wt(l,naver+1)=0.d0 
         enddo
        enddo
        naver=naver+1
        name(naver)=p(1)
        units(naver)=p(2)
       call mean(ndata,a(start,naver),wt(start,naver)
     .    ,name(naver),units(naver))
       go to 9
        
10     continue
      inquire(file='.trace',exist=ifex)
      if(ifex) go to 30
      write (1,*)' file .trace does not exist '
      go to 50
30    open(3,file='.trace',form='formatted')
      ntrace=0
39     j=ipickoff(3,p,n,mn)
      if(j.eq.1) go to 40
       if(ntrace.gt.mtrace) then
          write (*,*)' mtrace too small ',mtrace
          stop
        endif
         k=ifind(p(1),name,naver)
         if(k.le.0.or.k.gt.naver) then
               write (*,*)' symbol undefined ',p(1)
               go to 39 ! exit if symbol undefined
         endif
        ntrace=ntrace+1
        itrace(ntrace)=k
        write (*,*) k,ntrace
        go to 39

40    continue       
      if(ntrace.gt.0) then
      ln=index(filen,' ')-1
      open(99,file=filen(1:ln)//'.tr')
      do l=start,finish
       write (99,'(i5,10e12.5)')l,(a(l,itrace(k)),k=1,ntrace)
      enddo
      endif
         
        

50    continue
      call timedate(date)   ! end of report is date
!     write (1,*)' report time ',date
      end

      subroutine ofile(a,wt,name,units,naver,nsets,first,last
     . ,mblocks,maver,msets,filen)

      implicit real*8 (a-h,o-z)
      parameter (mn=20)
      real*8 a(mblocks,maver),wt(mblocks,maver)
      character filen*(*) ,date*26,name(maver)*16,units(maver)*16
     .,p(mn)*16
      logical ifex
      integer nblock(0:mblocks),first(msets),last(msets)

!10    write (*,*) ' what run?'
10    continue

      read (*,'(a14)') filen
      ln=index(filen,' ')-1
c does this file exist?
      inquire(file=filen(1:ln)//'.bsc',exist=ifex)
      if(ifex) go to 20
      write (*,*)' file .bsc does not exist '
      go to 10
20    open(62,file=filen(1:ln)//'.bsc',form='unformatted')
      inquire(file=filen(1:ln)//'.lsc',exist=ifex) 
      if(ifex) go to 30
      write (*,*)' file .lsc does not exist '
      go to 10
30    open(63,file=filen(1:ln)//'.lsc',form='formatted')
      open(1,file=filen(1:ln)//'.rep',form='formatted')
      write (1,*)'report for run ',filen(1:ln)

      ! load names of scalars into sc file
      naver=0
      do l=1,9999999
      j=ipickoff(63,p,n2,mn)
      if(j.eq.1) go to 40
!     if(p(1).eq.'(Average)') then
      if(n2.lt.2)then
       write(*,*)' short line ',n2
       stop
      endif
      n=intread(p(1))
      naver=max(naver,n)
      if(n.gt.maver.or.n.lt.0) then
         write (*,*)' maver too small ',l,n,maver
         stop
      endif
      name(naver)=p(2)
      units(naver)=p(3)
!     endif
      enddo

40    continue
      ! read scalar data
      nsets=0
      nblock(0)=-20

      do l=1,mblocks
       read (62,end=50) n,nblock(l),(a(l,i),wt(l,i),i=1,n)

       if(n.ne.naver) then
           write (*,*)'averages inconsistent ',l,n,naver
       endif
       if(nblock(l).le.0) then
           write (*,*)' bad block ',l,nblock(l)
       endif

       ntblocks=l
      if(ntblocks.eq.mblocks) then
          write (*,*)'mblocks too small',ntblocks
          stop
       endif
       if(nblock(l).eq.nblock(l-1)+1) then
         last(nsets)=l
       elseif(nblock(l).eq.1) then
         nsets=nsets+1
         if(nsets.gt.msets) then
          write (*,*)' msets too small',l,msets
          stop
         endif
         first(nsets)=l
       else
          write (*,*)'missing data'
          stop
       endif

       enddo
50     continue
!      write (*,*)' number of sets=',nsets
       write (1,*)' blocks/set ',(last(i)-first(i)+1,i=1,nsets)
!      write (*,*)' end of sets ',(last(i),i=1,nsets)
       return
       end

      subroutine mean(n,a,wt,name,units) !finds mean and error bars
      implicit real*8 (a-h,o-z)
      real*8 a(n),wt(n)
      character name*(*),units*(*)

      top=0.d0
      bot=0.d0
      wtsq=0.d0
      do i=1,n
         top=top+a(i)
         bot=bot+wt(i)
         wtsq=wtsq+wt(i)*wt(i)
      enddo
      if(wtsq.le.0.d0.or.bot.eq.0.d0)then
!           write (1,44) name,units,top,bot,wtsq
            return
      endif

      abar=top/bot  !best estimate of mean

      asq=0.d0 !uncorrelated errors
      m=0
      do i=1,n
         if(wt(i).ne.0.d0) then
          a(i)=a(i)/wt(i) -abar !a is now fluctuation
         asq=asq+ wt(i)*a(i)**2
         m=m+1
         else
          a(i)=0.d0   
         endif
      enddo

      if(n.eq.1) then
        asq=0.d0
      else
        asq=asq/(bot*(m-1.d0))
      endif
      if(asq.gt.0.d0) asq=sqrt(asq)

       do k=0,n-1 ! time displacement for autocorrelation
          cf=0.d0
          sw=0.d0
          do i=k+1,n
            w=1.d0 !equal weighting for c.f.
            cf=cf+w*a(i)*a(i-k)
            sw=sw+w
          enddo
          cf=cf/sw
            if(k.eq.0) then ! formula for correlation time
              tcf=cf
              var0=cf
            else
             if(cf.le..001*var0) go to 10 !cutoff sum when it goes negative
             tcf=tcf+2.d0*cf
            endif
       enddo
10    tcf=tcf/var0
      write (1,44) name,units,abar,sqrt(tcf)*asq,asq,bot**2/(n*wtsq),tcf
44    format(2a10,3e14.6,2f10.3)
       do i=1,n ! exit with a = normalized values
        a(i)=a(i)+abar
       enddo

       return
       end
