      program coself
      parameter (msl2=110,mnsh=20,mne=100,mlong=10)
      implicit real*8 (a-h,o-z)
      real*8 f(0:msl2,mnsh,mlong),fsum(0:msl2,mnsh)
     +,fbin(0:msl2,mnsh),w(0:msl2,mnsh),error(0:msl2,mnsh)
     +,covar(0:msl2,0:msl2,mnsh)
     +,hbs2m(5),rknorm(mnsh),dsave(mne,2,mnsh)
      character  filen*14,ft*14
      logical ifex

       write (*,*)'input l-value, bining'
       read (*,*) lvalue,ibin
       ibin=max(1,ibin)

      nblocks=0
      nbin=0
      do i=0,msl2
      do k=1,mnsh
      fsum(i,k)=0
      fbin(i,k)=0
        do j=0,msl2
          covar(i,j,k)=0
        enddo
      enddo
      enddo

c loop through reading the files
10    write (*,*) ' what file prefix or stop? '
      read (*,9) ft
9     format(a14)

      if(ft.eq.'stop') then
        go to 1000
      else
         ln=index(ft,' ')-1
         if(lvalue.eq.0) then
          filen=ft(1:ln)//'.bfkt'
          la=ln+5
          long=1
          lvt=1
         else
          filen=ft(1:ln)//'.bfs'
          la=ln+4
          lvt=lvalue
         endif
      endif

c does this file exist?
      inquire(file=filen(1:la),exist=ifex)
      if(ifex) go to 20
      write (*,*)' file does not exist '
      go to 10

20    open(1,file=filen(1:la),status='old',form='unformatted'
     + ,err=8010)

      if(lvalue.eq.0) then
      read (1,end=30,err=30) ntimes,nlamb,ntypes
     +  ,tau,beta,(hbs2m(i),i=1,ntypes)
     +  ,(rknorm(k),k=1,nlamb)
      else
      read (1,end=30,err=30) ntimes,nlamb,ntypes
     +  ,tau,beta,(hbs2m(i),i=1,ntypes)
     +  ,(rknorm(k),k=1,nlamb),long
      endif
      write (*,*) ntimes,nlamb,ntypes,tau,beta,hbs2m(1)
      if(ntimes*nlamb*ntypes.le.0)go to 10

15    continue
      do l=1,long
      do k=1,nlamb
      read (1,end=30,err=30) (f(j,k,l),j=0,ntimes)
      enddo
      enddo
c add to binned values
      nbin=nbin+1
      do k=1,nlamb
      do j=0,ntimes
      fbin(j,k)=fbin(j,k)+f(j,k,lvt)
      enddo
      enddo

      if(mod(nbin,ibin).eq.0) then
      xi=1./float(ibin)
      xi2=xi*xi
      do k=1,nlamb
       do j=0,ntimes
       fsum(j,k)=fsum(j,k)+fbin(j,k)*xi
       do j2=0,j
       covar(j,j2,k)=covar(j,j2,k)+fbin(j,k)*fbin(j2,k)*xi2
       enddo
       fbin(j,k)=0
       enddo
      enddo
      nblocks=nblocks+1
      endif

      go to 15

30     write (*,*) 'total number of blocks ',nblocks
       go to 10
1000  continue
       write (*,*)' input ne emin,emax '
       read (*,*) ne,emin,emax
       nvary=0
c now normalize the block averages and covariance
      xi=1./nblocks
      do k=1,nlamb
        do j=0,ntimes
         fsum(j,k)=xi*fsum(j,k)
         do j2=0,j
          covar(j,j2,k)=xi*(xi*covar(j,j2,k)-fsum(j,k)*fsum(j2,k))
          covar(j2,j,k)=covar(j,j2,k)
         enddo
         error(j,k)=sqrt(covar(j,j,k))
        enddo
c       write (3,*) (fsum(j,k),j=0,ntimes)
        write (*,*) ' '
        sum0=hbs2m(1)*rknorm(k)**2
        write (*,*) ' k= ',rknorm(k)
        write (*,*) 'error(0,beta/2)=',(error(j,k),j=0,ntimes,ntimes)
c find singular values of covariance matrix
        call rot(covar(0,0,k),msl2+1,ntimes+1,nsig,w(0,k))
        write (*,*) ' nsig = ', nsig

c do max ent reconstruction
        betab=beta*lvt
        if(lvt.eq.long)betab=10*betab
        if(ne.gt.0) 
     +  call maxent(tau,beta,ntimes+1,fsum(0,k),nsig
     +    ,covar(0,0,k),msl2+1,sum0,dsave(1,1,k),ne,mne
     +    ,nvary,emin,emax,rknorm(k),lvalue)

     
      enddo
c write out covariance eigenvalues
      do i=0,ntimes
      write(11,13) (w(i,k),k=1,nlamb)
      enddo
13    format(10e11.4)
c write out fkt and errors on units 81 82
      do j=0,ntimes
       write (81,810) tau*j,(fsum(j,k),k=1,nlamb)
       write (82,810) tau*j,(error(j,k),k=1,nlamb)
810    format(11e13.5)
      enddo
c now write out dsave
      write (12,*)' kvalues nlamb=',nlamb
      write (12,12) 0.,(rknorm(k),k=1,nlamb)
      write (12,*) ' variable energies and strengths ',nvary
      do i=1,nvary
      write (12,12) 0.,(dsave(ie,2,k),k=1,nlamb)
      write (12,12) 0.,(dsave(ie,1,k),k=1,nlamb)
      enddo
      write (12,*)' fixed spectral density ne=',ne-nvary
      do i=nvary+1,ne
      write (12,12) dsave(i,2,1),(dsave(i,1,k),k=1,nlamb)
      enddo
12    format(11f9.4)

       stop

8010   write(*,*) '  can not open file ',filen(1:ln)
       stop
8020   write(*,*) '  can not read file ',filen(1:ln)
       stop
       end

      subroutine rot(covar,mdata,n,nsig,w)
      implicit real*8 (a-h,o-z)
      parameter (md=110)
      real*8 covar(mdata,mdata),u(md,md),w(mdata)
c now set up rhs and lhs and solve linear equations
       call svdcmp(covar,n,n,mdata,mdata,w,u)
              nsig=0
              wmax=0.
              do j=1,n
                wmax=max(w(j),wmax)
              enddo
              thresh=1.e-7*wmax
              do j=1,n
               if(w(j).ge.thresh) then 
               nsig=nsig+1
                sw=1./sqrt(w(j))
                do  k=1,n
                 covar(k,nsig)=u(k,j)*sw
                enddo
                endif
              enddo

c now do singular value decomposition
c     job=10
c     n=ndata
c     call ssvdc(covar,mdata,n,n,w,f,u,mdata,u,mdata,work,job,info)
c     write (*,*)' info from ssvdc ',info,' ndata =',ndata,w(1)
c     if(info.ne.0) stop
c     w1i=1./w(1)
c     write (*,77)(w(i)*w1i,i=1,n)
77    format(' sv',8e9.2)
c       do 99 j=1,n
c99    write (*,78) (u(i,j),i=1,n)
c       do 98 j=1,n
c98     write (*,78) (v(i,j),i=1,n)
78    format(' u ',5e10.3)
c     write (*,*)' exponent cutoff?'
c     read (*,*) expn
c     expn=1.e-5
c     nsig=0
c     do 720 i=1,n
c     if(w(i).gt.expn*w(1)) then
c       nsig=nsig+1
c normalize u by 1/sqrt(w)
c       sw=1./sqrt(w(i))
c       do 730 k=1,n
c730     u(k,nsig)=u(k,i)*sw
c     endif
c720   continue
c     write (*,*) ' number of significant  data points ',nsig
c     write (3,*) nsig,n
c      do 750 i=1,nsig
c750   write (3,751) (u(k,i),k=1,n)
c751   format(5e14.7)
      return
      end

      subroutine maxent(taut,betat,ntimest,fsum,nsigt,covar,mdata,sum0t
     +,dsave,net,mnet,nvaryt,emin,emax,rkt,lvt )
      implicit real*8 (a-h,o-z)

      parameter (mne=100,mt=110,msig=110)
      common/chi2r/alpha,entropy,chisq,d(mne,2)
     +,tau,beta,sum0,rsum,sparm,aexp
     +,f(mt),delta(mt),ernal(mt,mne),u(mt,msig)
     +,default(mne),amat(mne,msig)
      common/chi2i/ne,nvary,nsig,ntimes,lv

      parameter (mnv=mne+1,mnv2=mnv*(mnv+1)/2)
      real*8 fsum(ntimes),covar(mdata,nsig),ap(2*mne),dsave(mnet,2)

1     format(3f12.4)
c     now map everything into appropriate arrays
      lv=lvt
      if(ntimest.gt.mt)stop
      if(nsigt.gt.msig)stop
      nsig=nsigt
      nvary=0
c     ntimes=min(ntimest,int(.5*betat/taut+1.0001))
      ntimes=ntimest

      tau=taut
      beta=betat
      sum0=sum0t
      sparm=10000.
      aexp=1+.5*nsigt

      do i=1,ntimes
      f(i)=fsum(i)
        do il=1,nsig
        u(i,il)=covar(i,il)
        enddo
      enddo

      ne=net
      if(ne.gt.mne)stop

c initial values of energy
      omega= 10.
      gamma=omega
      dn=fsum(1)/ne
      de=(emax-emin)/(ne-1)
      s0=4*de*sum0*omega/3.1415

      do ie=1,ne
      d(ie,2)=emin+de*(ie-1)
      denom=(d(ie,2)**2-omega**2)**2+(2*d(ie,2)*gamma)**2 
      default(ie)=s0*d(ie,2)/((1.-exp(-beta*d(ie,2)) )*denom)
c     default(ie)=1.
      d(ie,1)= default(ie)
      enddo

      np=ne+nvary +1
      if(np.gt.mnv)stop
      do ie=1,ne
      call pfunc(tau,beta,d(ie,2),ntimes,ernal(1,ie))
      ap(ie)=sqrt(d(ie,1))
      enddo

c     do ie=1,nvary
c     ap(ie+ne)=d(ie,2)
c     enddo
      ap(np)=1.

c set up amat
      do ie=1,ne
      do il=1,nsig
      amat(ie,il)=0.
       do it=1,ntimes
       amat(ie,il)=amat(ie,il)+ernal(it,ie)*u(it,il)
       enddo
      enddo
      enddo

      ftol=.00001
      call frprmn(ap,np,ftol,iter,fret)
      write (*,*) '  iter fret ',iter,fret
      xxx=func(ap)
      write (*,*) ' final chi = ', chisq,entropy,alpha,rsum
c normalize spectrum
        do i=1,ne
        dsave(i,1)=d(i,1)
        dsave(i,2)=d(i,2)
        enddo
        dmx=0.
        do i=1,ne
        if(i.eq.1) then
           de=1./abs(dsave(2,2)-dsave(1,2))
        elseif(i.eq.ne) then
           de=1./abs(dsave(ne,2)-dsave(ne-1,2))
        else
           de=2./abs(dsave(i+1,2)-dsave(i-1,2))
        endif
           dsave(i,1)=de*dsave(i,1)
           if(dsave(i,1).gt.dmx) then
              emx=dsave(i,2)
              dmx=dsave(i,1)
           endif
        enddo

      write (9,9) rkt,chisq,alpha,rsum,dmx,emx
9     format(4f10.4,10f10.4)
      return
      end

      function func(a)
      implicit real*8 (a-h,o-z)
      real*8 a(2)

      parameter (mne=100,mt=110,msig=110)
      common/chi2r/alpha,entropy,chisq,d(mne,2)
     +,tau,beta,sum0,rsum,sparm,aexp
     +,f(mt),delta(mt),ernal(mt,mne),u(mt,msig)
     +,default(mne),amat(mne,msig)
      common/chi2i/ne,nvary,nsig,ntimes,lv

c     first map a parameters to  energies and s(k,w)
      sum=0.
      do ie=1,ne
       d(ie,1)=a(ie)**2
       sum=sum+d(ie,2)*d(ie,1)
      enddo
      rsum=sum/sum0

c find descrepancy in time
      do i=1,ntimes
      delta(i)=-f(i)
        do ie=1,ne
        delta(i)=delta(i)+d(ie,1)*ernal(i,ie)
        enddo
      enddo

c now rotate to direction of errors
      chisq=0.
      do il=1,nsig
        comp=0.
        do i=1,ntimes
        comp=comp+delta(i)*u(i,il)
        enddo
      chisq=chisq+comp**2
      enddo

c now  entropy
      alpha=a(ne+1)**2
      entropy=0.
      do ie=1,ne
      entropy=entropy-alpha*(d(ie,1)-default(ie)
     +            -d(ie,1)*log(d(ie,1)/default(ie))  )
      enddo

      func=.5*chisq+entropy-aexp*log(alpha)+sparm*(rsum-1)**2
      return
      end

      subroutine pfunc(tau,beta,e,ntimes,ernal)
      implicit real*8  (a-h,o-z)
      real*8 ernal(ntimes)
      x=exp(-tau*e)
      xi=1./x
      f=1.
      fi=exp(-beta*e)

      do i=1,ntimes
      ernal(i)=f+fi
      f=f*x
      fi=fi*xi
      enddo

      return
      end

      subroutine dfunc(a,grad)
      implicit real*8 (a-h,o-z)
      real*8 a(2),grad(2)

      parameter (mne=100,mt=110,msig=110)
      common/chi2r/alpha,entropy,chisq,d(mne,2)
     +,tau,beta,sum0,rsum,sparm,aexp
     +,f(mt),delta(mt),ernal(mt,mne),u(mt,msig)
     +,default(mne),amat(mne,msig)
      common/chi2i/ne,nvary,nsig,ntimes,lv

c     first map a parameters to  energies and s(k,w)
      sum=0.
      do ie=1,ne
       d(ie,1)=a(ie)**2
       sum=sum+d(ie,2)*d(ie,1)
      enddo

      cgrad=2*sparm*(sum/sum0-1)/sum0
      do ie=1,ne
      grad(ie)=cgrad*d(ie,2)
      enddo

c find descrepancy in time
      do i=1,ntimes
      delta(i)=-f(i)
        do ie=1,ne
        delta(i)=delta(i)+d(ie,1)*ernal(i,ie)
        enddo
      enddo

c now rotate to direction of errors
      do il=1,nsig
        comp=0.
        do i=1,ntimes
        comp=comp+delta(i)*u(i,il)
        enddo
        do ie=1,ne
        grad(ie)=grad(ie)+comp*amat(ie,il)
        enddo
      enddo

c now  entropy
      alpha=a(ne+1)**2
      entropy=0.
      do ie=1,ne
      diff=log(d(ie,1)/default(ie))
      entropy=entropy-alpha*(d(ie,1)-default(ie)-d(ie,1)*diff)
      grad(ie)=grad(ie)+alpha*diff
      enddo
      grad(ne+1)=(entropy-aexp)/alpha

c multiply by 2*a
      do i=1,ne+1
      grad(i)=2*a(i)*grad(i)
      enddo
      return
      end
