      program covar
      parameter (msl2=40,mnsh=20,mne=10)
      implicit real*8 (a-h,o-z)
      real*8 f(0:msl2,mnsh),fsum(0:msl2,mnsh),covar(0:msl2,0:msl2,mnsh)
     +,hbs2m(5),rknorm(mnsh),dsave(mne,2,mnsh)
      character  filen*14,ft*14
      logical ifex

c old style defaults
      tau=.025
      beta=2.
      hbs2m(1)=6.06
      open(1,file='kvect')
      read (1,*) (rknorm(k),k=1,10)
      close(1)
      ne=5

      nblocks=0
      do i=0,msl2
      do k=1,mnsh
      fsum(i,k)=0
      do j=0,msl2
      covar(i,j,k)=0
      enddo
      enddo
      enddo

10    write (*,*) ' what file prefix? stop to stop'
      read (*,9) ft
9     format(a14)
      if(ft.eq.'!!')then
        ft=filen
      elseif(ft.eq.'stop') then
        go to 1000
      else
      ln=index(ft,' ')-1
        filen=ft(1:ln)//'.bfkt'
      endif

c does this file exist?
      inquire(file=filen(1:ln+5),exist=ifex)
      if(ifex) go to 20
      write (*,*)' file does not exist '
      go to 10

20    open(1,file=filen(1:ln+5),status='old',form='unformatted'
     + ,err=8010)
      read (1,end=30,err=30) ntimes,nlamb,ntypes
c    +  ,tau,beta,(hbs2m(i),i=1,ntypes)
c    +  ,(rknorm(k),k=1,nlamb)
      write (*,*) ntimes,nlamb,ntypes,tau,beta,hbs2m(1)
      if(ntimes*nlamb*ntypes.le.0)go to 10

15    continue
      do k=1,nlamb
      read (1,end=30,err=30) (f(j,k),j=0,ntimes)
      enddo
      do k=1,nlamb
       do j=0,ntimes
       fsum(j,k)=fsum(j,k)+f(j,k)
       do j2=0,j
       covar(j,j2,k)=covar(j,j2,k)+f(j,k)*f(j2,k)
       enddo
       enddo
      enddo
      nblocks=nblocks+1
      go to 15

30     write (*,*) 'total number of blocks ',nblocks
       go to 10
1000  continue
c     write (3,*) 1,1,ntimes+1,1,netimes+1
c     write (3,*) tau,0.
c now normalize the block averages and covariance
      xi=1./nblocks
      do k=1,nlamb
        do j=0,ntimes
         fsum(j,k)=xi*fsum(j,k)
         do j2=0,j
          covar(j,j2,k)=xi*(xi*covar(j,j2,k)-fsum(j,k)*fsum(j2,k))
          covar(j2,j,k)=covar(j,j2,k)
         enddo
        enddo
c       write (3,*) (fsum(j,k),j=0,ntimes)
c find singular values of covariance matrix
        call rot(covar(0,0,k),msl2+1,ntimes+1,nsig)
c do max ent reconstruction
        write (*,*) ' k= ',rknorm(k),' nsig = ', nsig
        sum0=hbs2m(1)*rknorm(k)**2
        call maxent(tau,beta,ntimes+1,fsum(0,k),nsig
     +    ,covar(0,0,k),msl2+1,sum0,dsave(1,1,k),ne,mne)
      enddo
c now write out dsave
      write (12,12) (rknorm(k),k=1,nlamb)
      write (12,12) (dsave(1,2,k),k=1,nlamb)
      write (12,12) (dsave(1,1,k),k=1,nlamb)
      do i=1,ne
      write (12,12) dsave(i,2,1),(dsave(i,1,k),k=1,nlamb)
      enddo
12    format(11f10.4)

       stop

8010   write(*,*) '  can not open file ',filen(1:ln)
       stop
8020   write(*,*) '  can not read file ',filen(1:ln)
       stop
       end

      subroutine rot(covar,mdata,n,nsig)
      implicit real*8 (a-h,o-z)
      parameter (md=100)
      real*8 covar(mdata,mdata),w(md),work(md),f(md)
     +,u(md,md)
c now set up rhs and lhs and solve linear equations
       call svdcmp(covar,n,n,mdata,mdata,w,u)
              nsig=0
              wmax=0.
              do j=1,n
                wmax=max(w(j),wmax)
              enddo
              thresh=1.e-5*wmax
              do j=1,n
               if(w(j).ge.thresh) then 
               nsig=nsig+1
                sw=1./sqrt(w(j))
                do  k=1,n
                 covar(k,nsig)=u(k,j)*sw
                enddo
                endif
              enddo

c now do singular value decomposition
c     job=10
c     n=ndata
c     call ssvdc(covar,mdata,n,n,w,f,u,mdata,u,mdata,work,job,info)
c     write (*,*)' info from ssvdc ',info,' ndata =',ndata,w(1)
c     if(info.ne.0) stop
c     w1i=1./w(1)
c     write (*,77)(w(i)*w1i,i=1,n)
77    format(' sv',8e9.2)
c       do 99 j=1,n
c99    write (*,78) (u(i,j),i=1,n)
c       do 98 j=1,n
c98     write (*,78) (v(i,j),i=1,n)
78    format(' u ',5e10.3)
c     write (*,*)' exponent cutoff?'
c     read (*,*) expn
c     expn=1.e-5
c     nsig=0
c     do 720 i=1,n
c     if(w(i).gt.expn*w(1)) then
c       nsig=nsig+1
c normalize u by 1/sqrt(w)
c       sw=1./sqrt(w(i))
c       do 730 k=1,n
c730     u(k,nsig)=u(k,i)*sw
c     endif
c720   continue
c     write (*,*) ' number of significant  data points ',nsig
c     write (3,*) nsig,n
c      do 750 i=1,nsig
c750   write (3,751) (u(k,i),k=1,n)
c751   format(5e14.7)
      return
      end

      subroutine maxent(taut,betat,ntimest,fsum,nsigt,covar,mdata,sum0t
     +,dsave,net,mnet)
      implicit real*8 (a-h,o-z)

      parameter (mne=50,mt=50,msig=50)
      common/chi2r/alpha,entropy,chisq,d(mne,2)
     +,tau,beta,sum0,sum,sparm
     +,f(mt),delta(mt),ernal(mt,mne),u(mt,msig)
      common/chi2i/ne,nvary,nsig,ntimes

      parameter (mnv=mne+1,mnv2=mnv*(mnv+1)/2)
      real*8 fsum(ntimes),covar(mdata,nsig),ap(2*mne),am(mnv)
     +,g(mnv),h(mnv2),w(4*mnv),dsave(mnet,2)
      external prob

1     format(3f12.4)
c     now map everything into appropriate arrays
      if(ntimest.gt.mt)stop
      if(nsigt.gt.msig)stop
      nsig=nsigt
      ntimes=ntimest
      tau=taut
      beta=betat
      sum0=sum0t
      sparm=10000.

      do i=1,ntimes
      f(i)=fsum(i)
        do il=1,nsig
        u(i,il)=covar(i,il)
        enddo
      enddo

c initial values of energy
      ne=net
      if(ne.gt.mne)stop
      nvary=1
      e=-log(fsum(2)/fsum(1))/tau
c     write (*,1) fsum(1),fsum(2),e
      d(1,2)=e
      d(1,1)=fsum(1)

      if(ne.gt.2) then
      emin=30.
      emax=60.
      de=(emax-emin)/(ne-2)
      do ie=2,ne
      d(ie,2)=emin+de*(ie-2)
      d(ie,1)=.1*d(1,1)
      enddo
      endif

      do ie=1,ne
      call pfunc(tau,beta,d(ie,2),ntimes,ernal(1,ie))
      ap(ie)=sqrt(d(ie,1))
      ap(ie+ne)=d(ie,2)
      enddo

      np=ne+nvary +1
      ap(np)=1.
      if(np.gt.mnv)stop
      call prob(np,ap,chi)
c     write (*,*) ' initial chi = ', chi,entropy
      maxfn=2000*ne
      iprint=maxfn+1
      eps=1.e-6
      hh=1.e-6
      mode=1
      dfn=-.9 

      do i=1,np
      am(i)=abs(ap(i))
      enddo

      call va10a(prob,np,ap,chi,g,h,w,dfn,am
     $ , hh, eps, mode, maxfn, iprint, iexit)

      call prob(np,ap,chi)
      write (*,*) ' final chi = ', chi,entropy
      write (9,9) iexit,chi,alpha,sum,(d(i,1),d(i,2),i=1,ne)
9     format(i2,4f10.4,10f10.4)
      do i=1,ne
      dsave(i,1)=d(i,1)
      dsave(i,2)=d(i,2)
      enddo
      return
      end

      subroutine prob(np,a,chi)
      implicit real*8 (a-h,o-z)
      real*8 a(np)
      parameter (mne=50,mt=50,msig=50)
      common/chi2r/alpha,entropy,chisq,d(mne,2)
     +,tau,beta,sum0,sum,sparm
     +,f(mt),delta(mt),ernal(mt,mne),u(mt,msig)
      common/chi2i/ne,nvary,nsig,ntimes
c     first map a parameters to  energies and s(k,w)
      do ie=1,ne
      d(ie,1)=a(ie)**2
      enddo
c change energies and ernal
      do ie=1,nvary
      d(ie,2)=a(ne+ie)
      call pfunc(tau,beta,d(ie,2),ntimes,ernal(1,ie))
      enddo
c for fsum-rule
      sum=0.
      do ie=1,ne
       sum=sum+d(ie,2)*d(ie,1)
      enddo

c find descrepancy in time
      do i=1,ntimes
      delta(i)=-f(i)
        do ie=1,ne
        delta(i)=delta(i)+d(ie,1)*ernal(i,ie)
        enddo
      enddo
c now rotate to direction of errors
      chisq=0.
      do il=1,nsig
        comp=0.
        do i=1,ntimes
        comp=comp+delta(i)*u(i,il)
        enddo
      chisq=chisq+comp**2
      enddo
c now  entropy
      alpha=a(np)**2
      entropy=0.
      do ie=1,ne
      entropy=entropy-alpha*(d(ie,1)-1.-d(ie,1)*log(d(ie,1)))
      enddo
      chi=.5*chisq+entropy-log(alpha)+sparm*(sum/sum0-1)**2
      return
      end

      subroutine pfunc(tau,beta,e,ntimes,ernal)
      implicit real*8  (a-h,o-z)
      real*8 ernal(ntimes)
      x=exp(-tau*e)
      xi=1./x
      f=1.
      fi=exp(-beta*e)
      do i=1,ntimes
      ernal(i)=f+fi
      f=f*x
      fi=fi*xi
      enddo
      return
      end
