      parameter (mdim=3,mnp=10,mnpts=400)
      real*8 r(mdim,mnp),w(mnpts,2),kappae,kappau,ww(mnpts)
      character*8 qid

      ndim=3
      nparts=3

c here are variables that specify the final grid
       nnew=120
       r0=.2
       rmax=8.0
       dr=(rmax-r0)/(nnew-1)
c here are the 3 variables that specify the subgrid
      npts=16
      a0=1.45
      amax=3.5
c map them to r grid points
       nskip=(amax-a0)/(dr*(npts-1))+.4
       nf=(a0-r0)/dr+1.49999
       a0=r0+(nf-1)*dr
       da=nskip*dr
       write (*,*) a0,da,a0+(npts-1)*da
       write (*,*) nf,nskip,nf+(npts-1)*nskip

c end of grid
      levels=2
      hbs2m=6.059
      nsteps=20000
       write (*,*)' job id'
        read (*,58) qid
   58   format(a)
        ln=index(qid,' ')-1
      write (*,*)' temperature?'
      read (*,*) temp
       tau=1./temp

      write (*,*)' input mode  0 or nonzero'
      read (*,*) mode
      if(mode.eq.0) then
      open(1,file=qid(1:ln)//'.sy')
      open(2,file=qid(1:ln)//'.co')

      write(1,*)'BOXSIZE 30. 30. 30.'
      write(1,*)'BETA ',tau
      write(1,*)'NSLICES ',2**levels
      write(1,*)'TYPE He4 ',hbs2m,'   0 ' ,nparts,' tri.ic'
      write(1,*)' POT PAIR  He4   He4   he4.dm  3 3'
      write(1,*)'RESTART'
      write(1,*)'ACT ',npts,' ',nsteps,' ',qid(1:ln)//'.co'

      do l=1,ndim
      do i=l,nparts
      r(l,i)=0
      enddo
      enddo
  
      do k=1,npts
      a=a0+da*(k-1)
c here are coordinates of the triangle
      r(1,2)=a
      r(1,3)=.5*a
      r(2,3)=sqrt(.75)*a
    
      do kk=1,2
      do i=1,nparts
      write (2,99) (r(l,i),l=1,ndim)
99    format(3f10.5)
      enddo
      enddo
      enddo

      else
c now output gradient functions
c read .act file
       kappau=tau/12.
        kappae=1./4.
       cnstu=1./sqrt(3.*kappau*hbs2m)
       cnste=1./sqrt(3.*kappae*hbs2m)
       open(4,file=qid(1:ln)//'.act')
       open(10,file=qid(1:ln)//'.w')
       do k=1,npts
       a=a0+da*(k-1)
       read (4,*) i,u0,e0
       do l=1,levels
       read (4,*) u,err,e,erre
       enddo
       deltau=u0-u
       deltae=e0-e
       w(k,1)=cnstu*sqrt(abs(deltau))/a
       w(k,2)=cnste*sqrt(abs(deltae))/a
       write (*,*) a,w(k,1),deltau,.5*w(k,1)*err/abs(deltau)
       write (*,*) a,w(k,2),deltae,.5*w(k,2)*err/abs(deltae)
       enddo

C now go over old gid
       write (10,*) 'RANK 3 ',nnew,1,1
       write (10,*)'BEGIN 5'

         do ie=1,2
       do k=1,nf-1
       ww(k)=w(1,ie)
       enddo

       k=nf-1
       do k0=1,npts-1
       k=k+1
       ww(k)=w(k0,ie)
       do l=1,nskip-1
       x=l/float(nskip)
       k=k+1
       ww(k)=w(k0,ie)+x*(w(k0+1,ie)-w(k0,ie))
       enddo
       enddo

       ww(k+1)=w(npts,ie)
       do i=k+2,nnew
       ww(i)=0.
       enddo
       write (10,12) (ww(k),k=1,nnew)
12      format(5f12.5)
      enddo
      endif
       end
