      program fktpack
      parameter (msl2=110,mnsh=20,mne=50,mlong=10)
      implicit real*8 (a-h,o-z)
      real*8 f(0:msl2,mnsh,mlong),fsum(0:msl2,mnsh)
     +,covar(0:msl2,0:msl2,mnsh)
     +,hbs2m(5),rknorm(mnsh),dsave(mne,2,mnsh)
      character  filen*14,ft*14
      logical ifex

      write (*,*)' input k-value l-lvalue '
      read (*,*)kvalue,lvalue

      nblocks=0
      do i=0,msl2
      do k=1,mnsh
      fsum(i,k)=0
      do j=0,msl2
      covar(i,j,k)=0
      enddo
      enddo
      enddo

10    write (*,*) ' what file prefix? stop to stop'
      read (*,9) ft
9     format(a14)
      if(ft.eq.'!!')then
        ft=filen
      elseif(ft.eq.'stop') then
        go to 1000
      else
         ln=index(ft,' ')-1
         if(lvalue.eq.0) then
          filen=ft(1:ln)//'.bfkt'
          la=ln+5
          long=1
          lvt=1
         else
          filen=ft(1:ln)//'.bfs'
          la=ln+4
          lvt=lvalue
         endif
      endif

c does this file exist?
      inquire(file=filen(1:la),exist=ifex)
      if(ifex) go to 20
      write (*,*)' file does not exist '
      go to 10

20    open(1,file=filen(1:la),status='old',form='unformatted'
     + ,err=8010)
      if(lvalue.eq.0) then
      read (1,end=30,err=30) ntimes,nlamb,ntypes
     +  ,tau,beta,(hbs2m(i),i=1,ntypes)
     +  ,(rknorm(k),k=1,nlamb)
      else
      read (1,end=30,err=30) ntimes,nlamb,ntypes
     +  ,tau,beta,(hbs2m(i),i=1,ntypes)
     +  ,(rknorm(k),k=1,nlamb),long
      endif
      write (*,*) ntimes,nlamb,ntypes,tau,beta,hbs2m(1)
      if(ntimes*nlamb*ntypes.le.0)go to 10

15    continue
      do l=1,long
      do k=1,nlamb
      read (1,end=30,err=30) (f(j,k,l),j=0,ntimes)
      enddo
      enddo

      do k=1,nlamb
       do j=0,ntimes
       fsum(j,k)=fsum(j,k)+f(j,k,lvt)
       do j2=0,j
       covar(j,j2,k)=covar(j,j2,k)+f(j,k,lvt)*f(j2,k,lvt)
       enddo
       enddo
      enddo

      nblocks=nblocks+1
      if(nblocks.eq.1) then
       write (80,*)' L Beta'
       write (80,*) ntimes+1,beta
      endif
       write (80,*)' bin'
       write (80,81) (f(j,kvalue,lvt),j=0,ntimes)
81     format(5e13.5)

      go to 15

30     write (*,*) 'total number of blocks ',nblocks
       go to 10
1000  continue
c     write (3,*) 1,1,ntimes+1,1,netimes+1
c     write (3,*) tau,0.
c now normalize the block averages and covariance
      xi=1./nblocks
      do k=1,nlamb
        do j=0,ntimes
         fsum(j,k)=xi*fsum(j,k)
         do j2=0,j
          covar(j,j2,k)=xi*(xi*covar(j,j2,k)-fsum(j,k)*fsum(j2,k))
          covar(j2,j,k)=covar(j,j2,k)
         enddo
        enddo
c       write (3,*) (fsum(j,k),j=0,ntimes)
c find singular values of covariance matrix
        write (*,*)' enter rot k=',k
c       call rot(covar(0,0,k),msl2+1,ntimes+1,nsig)
c do max ent reconstruction
        write (*,*) ' k= ',rknorm(k),' nsig = ', nsig
      enddo

      do j=0,ntimes
       write (81,810) tau*j,(fsum(j,k),k=1,nlamb)
       write (82,810) tau*j,(sqrt(covar(j,j,k)),k=1,nlamb)
810    format(11f9.4)
      enddo

       stop

8010   write(*,*) '  can not open file ',filen(1:ln)
       stop
8020   write(*,*) '  can not read file ',filen(1:ln)
       stop
       end

      subroutine rot(covar,mdata,n,nsig)
      implicit real*8 (a-h,o-z)
      parameter (md=110)
      real*8 covar(mdata,mdata),w(md),work(md),f(md)
     +,u(md,md)
c now set up rhs and lhs and solve linear equations
       call svdcmp(covar,n,n,mdata,mdata,w,u)
              nsig=0
              wmax=0.
              do j=1,n
                wmax=max(w(j),wmax)
              enddo
              thresh=1.e-8*wmax
              do j=1,n
               if(w(j).ge.thresh) then 
               nsig=nsig+1
                sw=1./sqrt(w(j))
                do  k=1,n
                 covar(k,nsig)=u(k,j)*sw
                enddo
                endif
              enddo

c now do singular value decomposition
c     job=10
c     n=ndata
c     call ssvdc(covar,mdata,n,n,w,f,u,mdata,u,mdata,work,job,info)
c     write (*,*)' info from ssvdc ',info,' ndata =',ndata,w(1)
c     if(info.ne.0) stop
c     w1i=1./w(1)
c     write (*,77)(w(i)*w1i,i=1,n)
77    format(' sv',8e9.2)
c       do 99 j=1,n
c99    write (*,78) (u(i,j),i=1,n)
c       do 98 j=1,n
c98     write (*,78) (v(i,j),i=1,n)
78    format(' u ',5e10.3)
c     write (*,*)' exponent cutoff?'
c     read (*,*) expn
c     expn=1.e-5
c     nsig=0
c     do 720 i=1,n
c     if(w(i).gt.expn*w(1)) then
c       nsig=nsig+1
c normalize u by 1/sqrt(w)
c       sw=1./sqrt(w(i))
c       do 730 k=1,n
c730     u(k,nsig)=u(k,i)*sw
c     endif
c720   continue
c     write (*,*) ' number of significant  data points ',nsig
c     write (3,*) nsig,n
c      do 750 i=1,nsig
c750   write (3,751) (u(k,i),k=1,n)
c751   format(5e14.7)
      return
      end
