      program ft
c finds ft of fkt.  then fits it to a pade
c on unit 12 (input) is fkt (produced by coself)
c on unit 83 (output) is skw
      parameter (mt=110,nsh=12,mw=1000,nm=20)
      implicit real*8 (a-h,o-z)
      real*8 tau(0:mt),fkt(nsh,0:mt),skw(nsh,0:mw),w(0:mw)
     +,a(nm,nm),b(nm),rk(nsh),as(nm,nm),bs(nm)
     +,top(0:nm),bot(0:nm),ww(nm),vv(nm,nm)
     +,skr(nsh,0:mw)
      complex*8 zbot(nm),ztop(nm),roots(nm),zsqrt(nm)
      integer indx(nm)

c number of k's
      nk=10
      read (12,90) 
90    format(80a1)
c unit 12 should have fkt
      read (12,*) hh,(rk(k),k=1,nk)
      do it=0,1000
      read (81,*,end=100) tau(it),(fkt(k,it),k=1,nk)
      ntimes=it
      enddo
100   write (*,*) ' number of steps =', ntimes,tau(ntimes)
      write (*,*) ' input assumed beta and ntimes'
      read (*,*) betap,ntimes
      pi=3.1415926535
      nw=mw
c     dw=80/(nw*tau(ntimes))
      dw=2*pi/betap
      dt=tau(1)-tau(0)

c now do fourier transform
      do iw=0,nw
      w(iw)=dw*iw
      do k=1,nk
      skw(k,iw)=0
      enddo

      do it=0,ntimes
      c=2*dt*cos(w(iw)*tau(it))
      if(it.eq.0.or.it.eq.ntimes) c=c*.5
      do k=1,nk
      skw(k,iw)=skw(k,iw)+c*fkt(k,it)
      enddo
      enddo

      write (83,83) w(iw),(skw(k,iw),k=1,nk)
83    format(11e13.5)
      enddo

c now try fitting them to some poles
      write (*,*)' input number of poles'
      read (*,*) npoles
      hbs2m=6.0626
      do k=1,nk
      fi=1/(hbs2m*rk(k)**2*fkt(k,0))
      f0=skw(k,0)
      n1=npoles-1
      n2=n1+1
      n3=2*npoles-2

c zero out matrices
      do i=1,n3
      b(i)=0
      do j=1,n3
      a(i,j)=0
      enddo
      enddo

c set up a and b by summing over frequencies
      do iw=1,nw
      s=skw(k,iw)
      ds=s-f0
      x=w(iw)**2
      z=1/x**2

        do kt=1,n1
        b(kt)=b(kt)+z*ds*x**kt
        b(kt+n1)= b(kt+n1)-s*ds*z*x**kt
          do jt=1,n1
          zz=z*x**(kt+jt)
c a-a matrix
            a(kt,jt)=a(kt,jt)+zz
c a-b and b-a
            a(kt,jt+n1)= a(kt,jt+n1)-zz*s
            a(jt+n1,kt)= a(jt+n1,kt)-zz*s
c b-b matrix
            a(kt+n1,jt+n1)= a(kt+n1,jt+n1)+zz*s*s
          enddo
        enddo

c now add the constraints
        b(n1)=b(n1)-z*s*fi*ds*x**npoles
        do kt=1,n1-1
          zz=fi*z*s*xx**(npoles+kt)
          a(kt,n1)=a(kt,n1)-zz
          a(n1,kt)=a(n1,kt)-zz
        enddo
        a(n1,n1)=a(n1,n1)+z*((1-s*fi*x)**2-1)*x**(2*n1)
        do kt=1,n1
          zz=fi*z*s**2*xx**(npoles+kt)
          a(n1+kt,n1)=a(n1+kt,n1)+zz
          a(n1,n1+kt)=a(n1,n1+kt)+zz
        enddo

      enddo

      do i=1,n3
      bs(i)=b(i)
      do j=1,n3
      as(i,j)=a(i,j)
      enddo
c     write (*,2) (a(i,j),j=1,n3),b(i)
      enddo

c now solve linear equations
      call ludcmp(a,n3,nm,indx,d)
      call lubksb(a,n3,nm,indx,b)

c     call svdcmp(a,n3,n3,nm,nm,ww,vv)
c     wmax=0.
c     do j=1,n3
c      if(ww(j).gt.wmax)wmax=ww(j)
c     enddo
c     wmin=1.e-10*wmax
c     do j=1,n3
c      if(ww(j).lt.wmin)ww(j)=0.
c     enddo
c     call svbksb(a,ww,vv,n3,n3,nm,nm,bs,b)
c     write (*,2) (b(i),i=1,n3)


c     do i=1,n3
c     dp=0.
c     do j=1,n3
c     dp=dp+as(i,j)*b(j)
c     enddo
c     write (*,2) i,dp,bs(i),dp-bs(i)
2     format(5e13.5)
c     enddo

      ntop=npoles-1
      top(0)=f0
      do i=1,n1
      top(i)=b(i)
      enddo
      write (*,2)(top(i),i=0,ntop)

      nbot=npoles
      bot(0)=1.
      do i=1,n1
      bot(i)=b(n1+i)
      enddo
      bot(n1+1)=fi*top(n1)
      write (*,2)(bot(i),i=0,nbot)

c now look at roots of the bottom
      do i=0,nbot
      zbot(i+1)=cmplx(bot(i),0.)
      ztop(i+1)=cmplx(top(i),0.)
      enddo

      write (3,*)' denominator roots',k,  rk(k)
      call zroots(zbot,nbot,roots,.true.)
      do i=1,nbot
      zsqrt(i)=sqrt(roots(i))
      write (3,3) i,roots(i),zsqrt(i)
3     format(1i5,4e13.5)
      enddo
      write (3,*)' numerator roots',k,  rk(k)
      call zroots(ztop,ntop,roots,.true.)
      do i=1,ntop
      zsqrt(i)=sqrt(roots(i))
      write (3,3) i,roots(i),zsqrt(i)
      enddo


      do iw=0,nw
       skw(k,iw)=poly(ntop,top(0),w(iw)**2)
     +          /poly(nbot,bot(0),w(iw)**2)
       skr(k,iw)=poly(ntop,top(0),-w(iw)**2)
     +          /poly(nbot,bot(0),-w(iw)**2)
      enddo
      enddo

c dump out approximate solutions on file 84
      do iw=0,nw
      write (84,83) w(iw),(skw(k,iw),k=1,nk)
      write (85,83) w(iw),(skr(k,iw),k=1,nk)
      enddo

      end

      function poly(na,a,x)
      implicit real*8 (a-h,o-z)
      real*8 a(0:na)

      poly=0
      do i=na,0,-1
      poly=a(i)+x*poly
      enddo

      return
      end
