      program potgen
      implicit real*8 (a-h,o-z)
c generates a potential table
      parameter (mn=10,mx=1000)
      dimension pott(mx),rv(mx),diff(mx),expon(20),cexpon(20)
      character fname*14,p(mn)*28,eunit*3,lunit*3
     +,pot(mn)*28,grid(mn)*28

      write (*,*)' input prefix of files '
      read (*,99) fname
99    format(a14)
      ln=index(fname,' ')-1
      open(1,file=fname(1:ln)//'.in')
c output file
      open (3,file=fname(1:ln)//'.dm',status='unknown')

      ntypes=0
      nx=0
      ifpair=0
c loop thru reading the input
1     continue
      j=ipickoff(1,p,n,mn)
      if(j.eq.1) go to 2
c repeat input on output
      call echo(3,p,n)

c input energy units and length units
      if(p(1).eq.'UNITS') then
      eunit=p(2)
      lunit=p(3)

c     elseif(p(1).eq.'TYPE')
c input type of particles and hbs2m
c      ntypes=ntypes+1
c      if(ntypes.gt.2)stop
 
      elseif(p(1).eq.'GRID')then
c input grid parameters
        do i=1,n
        grid(i)=p(i)
        enddo
        ng=n
        nx=intread(p(2))
        call setgrid(mx,nx,rv,grid(3))

      elseif(p(1).eq.'POT') then
c  input type of potential
        ifpair=ifpair+1
c store away the potential specification
        do i=2,n
         pot(i-1)=p(i)
        enddo
        np=n-1

      endif
      go to 1

2     continue
c check if potential and grid have been specified.
      if(ifpair.ne.1)stop
      if(nx.le.0)stop
c setup potential
      do i=1,nx
      call ipot(pot,np,pott(i),rv(i),eunit,lunit,ntail,expon,cexpon)
      enddo

c now check grid
      npts=10
      do i=1,nx-1
       diff(i)=0.
       do k=1,npts
         x=rv(i)+(rv(i+1)-rv(i))*k/(npts+1.)
         call ipot(pot,np,potx,x,eunit,lunit,ntail,expon,cexpon)   
         call interp(x,ix,a1,a2,a3,a4)
         dp=a1*pott(ix-1)+a2*pott(ix)+a3*pott(ix+1)+a4*pott(ix+2)-potx
         diff(i)=max(diff(i),abs(dp))
       enddo
         diff(nx)=diff(nx-1)
      enddo

c zero potential at cutr
      cutr=rlread(pot(2))
      call ipot(pot,np,pot0,cutr,eunit,lunit,ntail,expon,cexpon)
      write (3,33)pot0,ntail,(expon(i),cexpon(i),i=1,ntail)
33    format('POTTAIL ',e14.5,i3,5(f7.2,e13.5))
      do i=1,nx
       if(rv(i).le.cutr) then
         pott(i)=pott(i)-pot0
       else
         pott(i)=0
       endif
      enddo
 
      grid(2)='1 '
      write (3,*)'RANK 2 ',nx,1
      call echo(3,grid,ng)
      write (3,*)'LABEL 1 r'
      write (3,*)'BEGIN potential 0'
      write (3,969) (pott(i),i=1,nx)
969   format(4e16.7)
      close(3)

      open (9,file=fname(1:ln)//'.dg',status='unknown')
      write (9,*)'RANK 1 ',nx
      call echo(9,grid,ng)
      write (9,*)'LABEL 1 r'
      write (9,*)'BEGIN grid error'
      write (9,*) (diff(i),i=1,nx)
      close(9)
      stop
      end

      subroutine ipot(p,n,pott,rv,eunit,lunit,ntail,expon,cexpon)
      implicit real*8 (a-h,o-z)
c interprets potential parameter and sets up table.
      character p(n)*(*),eunit*(*),lunit*(*)
      dimension expon(10),cexpon(10)
      save icall
      data icall/0/
      data d,eps,a,alpha,c6,c8,c10/1.241314,10.8,544850.4,13.353384
     +,1.3732412,.4253785,.178100/
      data rm,beta/2.9673,0./
      icall=icall+1
      if(icall.eq.1)ntail=0

      if(p(1).eq.'HEDF2') then
c helium-helium (aziz-3) potential.
c       data eps,rm/10.948,2.963/
c       data a,alpha,beta,d,c6,c8,c10/184431.01,10.43329537,-2.27965105
c    +  ,1.4826,1.36745214,.42123807,.17473318/
c helium-helium (aziz-2) potential
       if(icall.eq.1) then
c      xe=convert('energy','meV',eunit)
c      xl=convert('length','au',lunit)
        ntail=3
        expon(1)=-6.
        cexpon(1)=-c6*eps*rm**6
        expon(2)=-8.
        cexpon(2)=-c8*eps*rm**8
        expon(3)=-10.
        cexpon(3)=-c10*eps*rm**10
        
       endif
 
        x=rv/rm
        a2i=1./(x*x)
        a6i=a2i*a2i*a2i
        if(x.lt.d) then
          f=exp(-(d/x-1.)**2)
        else
          f=1
        endif
         pott=eps*(a*exp(-alpha*x+beta*x*x)-f*a6i*
     +  (c6+a2i*(c8+a2i*c10)))
 
      elseif(p(1).eq.'COUL') then
      nexp=1
      cutr=rlread(p(2))
      accuracy=rlread(p(4))
      eps=rlread(p(3))

      if(accuracy.gt.0) then
        alpha=-.5*log(cutr*accuracy/abs(eps))/cutr**2
        call gammi(gr,.5*nexp,alpha*rv**2,gr0)
        pott=eps*gr/(gr0*rv**nexp)
       else
        pott=eps/rv**nexp
       endif

      elseif(p(1).eq.'SCCOUL') then
      if(icall.eq.1)then
       eps=rlread(p(3))
       rs=rlread(p(4))
      endif
       call epp(eps,rs,rv,pott)


      elseif(p(1).eq.'LJ') then
      if(icall.eq.1)then
       eps=rlread(p(3))
       sigma=rlread(p(4))
       ntail=2
       expon(1)=-6.
       cexpon(1)=4*eps*sigma**6
       expon(2)=-12.
       cexpon(2)=-4*eps*sigma**12
      endif
        x=rv/sigma
        a2i=1./(x*x)
        a6i=a2i*a2i*a2i
        pott=4*eps*a6i*(a6i-1.)

      else
         write (*,*)' this potential not defined ',p(1),n
         stop

      endif

      return
      end

      subroutine epp(q,rs,r,phir)
      implicit real*8 (a-h,o-z)
c finds the interaction between 2 protons in an electron gas
c rs is the electon gas density, the potential phir will be computed
c on the grid r. r is in atomic units. k in units of rs.
      parameter (nk=3200,dk=.02)
      dimension phik(nk),eps(nk)
      save pi,icall,phik,rsi
      data pi,icall/3.1415926535,0/

      if(icall.eq.0) then
c calculate fourier transform of phi(r)*r first time through
      call epsk(rs,eps,dk,nk)
      akn=dk/(.75*pi)
      rsi=1./rs

      do k=1,nk
      phik(k)=akn/(eps(k)*k*dk)
      if(mod(k,2).eq.1) phik(k)=2*phik(k)
      enddo
      phik(nk)=.5*phik(nk)
      endif
      icall=icall+1

      z=nk*dk*r*rsi
      zi=1./z
c  corrections for the FT at large k.
      phir=(2./pi)*zi*(cos(z)*(1.-2.*zi**2)+sin(z)*zi)

      do k=1,nk
      rk=k*dk*rsi
      phir=phir+phik(k)*sin(rk*r)
      enddo
 
      if(r*dk*nk.lt.2.) phir=1.
      phir=q*phir/r
      return
      end

      subroutine epsk(rs,eps,dk,nk)
      implicit real*8 (a-h,o-z)
      save pi,fwv
      dimension eps(nk)
      data pi/3.1415926535/
      data fwv /1.919158293/
      alp=.082929555*rs
      do 1 k=1,nk
      rk=k*dk
      eta=rk/(2*fwv)
      ff=1+(1-eta**2)*log((1+eta)/abs(1-eta))/(2.*eta)
1     eps(k)=1+1/(-g(rk,rs,ff)+eta**2/(alp*ff))
      return
      end

 
      function ecvwm(rs)
      implicit real*8 (a-h,o-z)
c correlation energy of the electron gas
      save x0,b,c,a
      xf(x)=c+x*(b+x)
      data x0,b,c/-.10498,3.72744,12.9352/
      data a/.0621814/
      q=sqrt(4*c-b**2)
      x=sqrt(rs)
      xc=xf(x)
      xc0=xf(x0)
      t=2*atan(q/(2*x+b))/q
      ecvwm=a*(log(x**2/xc)+b*t-b*x0*(log((x-x0)**2/xc)+(b+2*x0)*t
     +)/xc0)
      return
      end

      function ehf(rs)
      ehf=2.2099/rs**2-.91633/rs
      return
      end

  
      function g(rk,rs,ff)
      implicit real*8 (a-h,o-z)
      save a,b,c,b1,rls,fwv,fwvi
c local field correction
      data rls/0./
      data fwv /1.919158293/

      if(rls.ne.rs) then
c first time through find a b c b1
      ec=ecvwm(rs)
      ecp=ecvwm(rs+1.e-5)
      ecm=ecvwm(rs-1.e-5)
      de=.5e5 * (ecp-ecm)
      dde= 1.e10 * ( (ecp-ec) + (ecm-ec) )
      gm=.25-.0682068*rs**2*(rs*dde-2*de)
      g0=.125/bi1(1.62903*sqrt(rs))**2
      a=.029
      b=.5625*gm-3.*(1.-g0)/64. -16.*a/15.
      c=-.75*gm+.5625*(1.-g0)-3.2*a
      b1=b+8*a/3.
      fwvi=1./fwv
      rls=rs
      endif

      q=rk*fwvi
      q2=q**2
      g=c+q2*(b+a*q2)+(-c+q2*(b1+q2*a))*(ff-1.)
      return
      end
