      program scdiff
c     include 'mach.p'
      implicit real*8 (a-h,o-z)
      implicit integer (i-n)
      parameter (mncs=1000,mnsc=25)
c computes difference between 2 scalar files
c plus error estimates and histograms
c current bugs-histogram is on a slightly different scale than the trace
c    a scalar must be always defined
c    printed error bars are only for one blocking
c    correlation function not used
c    
c D. Ceperley 6/21/91
      dimension odata(mncs,mnsc,2)
      character qaname(mnsc)*8,units(mnsc)*8
      call rando(odata,npts1,ns1,qaname,units)
      call rando(odata(1,1,2),npts2,ns2,qaname,units)
      write (*,*)' quantity     mean           error          units
     +efficiency'
      ns=min(ns1,ns2)
      npts=min(npts1,npts2)
      do 10 i=1,ns
      asum=0.
      asq=0.
      do 20 l=1,npts
      diff=odata(l,i,2)-odata(l,i,1)
      asum=asum+diff
      asq=asq+diff**2
20    continue
      gmean=asum/npts
      if(gmean.ne.0.) then
      error=sqrt( ((asq/npts)-gmean**2) / (npts-1.))
      write (*,80)qaname(i),gmean,error,units(i),1.
80    format(a10,2e16.8,a10,f7.4)
      endif
10    continue
      stop 
      end

      subroutine rando(odata,ncs,ns,qaname,units)
c     include 'mach.p'
      parameter (mncs=1000,mnsc=25)
      dimension data(2,mncs,mnsc),idim(3),work(mncs,3),odata(mncs,mnsc)
      character name*(14),suf*(14),pre*(14),qaname(mnsc)*8
     +,units(mnsc)*8
      logical ifex
41    write (*,*) ' input run id?'
      read (*,2) name
2     format(a14)
        ln=index(name,' ')-1
      name=name(1:ln)//'.sc'
      ln=ln+5
c does this file exist?
        inquire(file=name(1:ln),exist=ifex)
        if(ifex) go to 40
         write (*,*)' file1 does not exist '
         go to 41
40    open(1,file=name)
      idim(1)=-mnsc
      idim(2)=4
      idim(3)=0
      call checkrnk(1,3,idim)
      write (*,*)' number of scalars found:',idim(1)
      ns=idim(1)
      call findbegn(1)
      write (*,*)' number of configs to throw away at beginning?'
      read (*,*) nskip
      l=1
      do 100 k=1,10000
c note we transpose the data
      read (1,*,end=3) (data(1,l,i),i=1,idim(1))
      read (1,*,end=3) (data(2,l,i),i=1,idim(1))
      read (1,91,end=3) (qaname(i),i=1,idim(1))
      read (1,91,end=3) (units(i),i=1,idim(1))
      do 120 i=1,idim(1)
      if(data(2,l,i).ne.0) then
         odata(l,i)=data(1,l,i)/data(2,l,i)
      else
         odata(l,i)=0.
      endif
120   continue
91    format(6a8)
92    format(6e18.10)
90    continue
      if(k.gt.nskip) l=l+1
      if(l.gt.mncs) go to 3
100   continue
3     ncs=l-1
      close(1)
      write (*,*)' number of configurations found:',ncs
       return
      end
