
      subroutine plint2(r,n,c,i0,pn,np)
      implicit real*8 (a-h,o-z)
      parameter (mbf=600)
      dimension c(9),bess(mbf+2)
c integrates besj0(r*x)*x**i for i from i0-1 to n+i0-2
c using formula 11.1.1 from Abramowitz and Stegun

      if(r.ge.1.e-5) then
c determine mbf bessel functions
       nbf=max0(100,6*int(r))
       if(nbf.gt.mbf) then 
         write (*,*) ' danger not enough space in plint2'
         nbf=mbf
       endif
       call mmbsjn(r,nbf,bess,ier)
c      if(ier.ne.0) write (*,*) 'problem in plint2 ',ier
       fact=1.e-10
       con=2./(exp(1.)*r)
      endif

      do 1 i=1,n+np
      nn=i+i0-2

      if(r.lt.1.e-5) then
      c(i)=1.
      else

      c(i)=bess(2)
      rat=1.
      do 2 k=4,nbf,2
      rat=rat*float(-nn+k-4)/float(nn+k)
      term=rat*bess(k)*(k-1)
      c(i)=c(i)+term
c stopping criterea: next term will be small relative to total.
2     if(abs(rat).lt.(con*k)**k*fact) go to 5
c     write (*,*) ' loop does not terminate in plint ',r,i,nbf
5     c(i)=2.*c(i)/r
      endif

1      c(i)=c(i)/(i+i0)
      call pmult(c,n,np,pn)
      return
      end
