      subroutine addtype(p,n)
c add a new type of particle
      include 'upi.cm'
      integer it,intread,nc,ncc,nf,is,ln,idim,k,j,jt,n,i,l,ir,ip,d
     &   ,li,lj,ifind,jdum
      real*8 rlread
      dimension idim(3)
      character p(n)*(*), filen*14,kename*8
      logical spread
      include 'cpbc.cm'

c generic stuff for particles,lines and planes
      is=ifind(p(2),pname,ntypes)
      if(is.gt.0)then
        write(*,*)' duplicate name of particle'
        stop
      endif
      if(ifewald.gt.0) then
        write (*,*)'please put EWALD after all ADDTYPE'
        stop
      endif

      ntypes=ntypes+1
      it=ntypes
      call mcheck(ntypes,mnc,'ntypes','mnc','addtype')
      if(it.eq.1)  nparts=0
      pname(it)=p(2)
      nfpty(it)=nparts+1
      nfpss(1,it)=nfpty(it)
c default is to use sampling tables in r-space but not k-space
      ifsamp(it)=1
      spread=.true.

      if(p(1).eq.'TYPE') then

c now for particles
      typep(it)=0
      el2type(it)=el2min
      hbs2m(it)=rlread(p(3))
      if(hbs2m(it).lt.0.) stop
      nspins(it)=intread(p(4))
      call mcheck(nspins(it),mnspin,'nspins','mnspin','addtype')
      ncomps(it)=intread(p(5))
      nppss(1,it)=ncomps(it)
      do j=1,nspins(it)
        nppss(j,it)=intread(p(5+j))
      enddo

c read in initial coordinates for this particle
      nf=6+max(nspins(it),0)
      filen=p(nf)

      if(filen(1:1).ne.'+') then
        call readcon(rperm(1,nfpty(it)),ndim,ncomps(it),ell,filen)
      else 
c read in aged configuration
        spread=.false.
        ln=index(filen,' ')-1
        open(21,file=filen(2:ln),status='old',form='formatted')
        write (6,*)' beginning read from ',filen
        idim(1)=ndim
        idim(2)=ncomps(it)
        idim(3)=nslices
        call checkrnk(21,3,idim)
        call findbegn(21)
        read(21,*)
     +  (((r(i,j+nfpty(it)-1,k),i=1,ndim),j=1,ncomps(it)),k=1,nslices)
        close(21)
      endif

      else

c now do line or plane types
      hbs2m(it)=0.
      nspins(it)=0
      ip=nfpty(it) -1
      ir=2
        if(p(1).eq.'LINE') then
          typep(it)=1
          el2type(it)=1.e100
          if(mod(n-2,ndim).ne.0)stop
          ncomps(it)=(n-2)/ndim

          do i=1,ncomps(it)
           nprojn=nprojn+1
           projn(1,nprojn)=ip+i
           projn(2,nprojn)=0

           do l=1,ndim
            ir=ir+1
            if(p(ir).eq.'|')then
              projn(2,nprojn)=l
              rperm(l,ip+i)=0.
            else
              rperm(l,ip+i)=rlread(p(ir))
              el2type(it)=min(el2type(it),el2(l))
           endif
           enddo
           if(projn(2,nprojn).eq.0)stop
          enddo

        elseif(p(1).eq.'PLANE') then
          typep(it)=2
          if(mod(n-2,2).ne.0)stop
          ncomps(it)=(n-2)/2
          do i=1,ncomps(it)
             d=intread(p(ir+1))
             if(d.gt.ndim.or.d.le.0)stop

             do l=1,ndim
               if(l.eq.d) then
                 rperm(l,ip+i)=rlread(p(ir+2))
                 el2type(it)=min(el2type(it),el2(l))
               else
                 rperm(l,ip+i)=0.
                 nprojn=nprojn+1
                 projn(1,nprojn)=ip+i
                 projn(2,nprojn)=l
               endif
             enddo
             ir=ir+2
          enddo

        endif
        call mcheck(nprojn,mpfile,'nprojn','mpfile','addtype')
      endif

c now back to generic case of particles,lines planes

c pointer for different ke components
      if(hbs2m(it).gt.0.) then
        ln=index(p(2),' ')-1
        kename='ke_'//p(2)(1:ln)
        call setav(jke(it),kename,eunit,1)
c numke is the number of kinetic energy components
        numke(it)=3
        call setav(jdum,kename(1:ln+3)//'.s',eunit,1)
        call setav(jdum,kename(1:ln+3)//'.u',eunit,1)
        call setav(jdum,kename(1:ln+3)//'.f',eunit,1)
        if(nspins(it).gt.0) then
           numke(it)=numke(it)+1
           call setav(jdum,kename(1:ln+3)//'.n',eunit,1)
        endif
      else
         numke(it)=0
      endif

      ifbf(it)=.false.
      nc=nparts
      nparts=nparts+ncomps(it)
      nlpss(1,it)=nparts
      call mcheck(nparts,mnp,'nparts','mnp','setsys')
c set up arrays for spin and type of particle
      do  i=nc+1,nparts
        idtype(i)=it
        idspin(i)=0
      enddo
      write (6,11) it,ncomps(it),hbs2m(it)
11    format(/' input for particle ',i5/' number ',i5,' hbs2m ',f12.6)
      write (6,*) '      density = ',ncomps(it)/vol
      write (6,15) nspins(it),(nppss(j,it),j=1,nspins(it))
15    format(' nspins ',i5,'number of particles/state ',4i5)

c set up arrays for nfpss nlpss idspin imatno
      ncc=0
      do j=1,nspins(it)
        nfpss(j,it)=nc+1
        nlpss(j,it)=nfpss(j,it)+nppss(j,it)-1
        nc=nc+nppss(j,it)
        ncc=ncc+nppss(j,it)
 
        write (6,25) j,nfpss(j,it),nppss(j,it),nlpss(j,it)
25      format(10x,' spin ',i2,' first particle ',i5,' number ',i5
     +            ,'last ',i5)
 
        do i=nfpss(j,it),nlpss(j,it)
          idspin(i)=j
        enddo
      enddo

      nlpty(it)=nparts
      write (6,35) nfpty(it),nlpty(it)
35    format(10x,' first and last particle of this type ',2i5)
      write (6,*)' dimensionality of this type ',typep(it)
      if(ncc.ne.ncomps(it).and.nspins(it).gt.0) then
        write (*,*) 'nppss does not add up to ncomps in addtype '
     +  ,ncc,ncomps
        stop
      endif


c give identity permutation
      do i=nfpty(it),nlpty(it)
      iperm(i)=i
      enddo

c copy initial condition into other time slices 
      if(spread) then
        do 40 i=nfpty(it),nlpty(it)
          do 40 l=1,ndim
          do 40 is=1,mslices
            r(l,i,is)=rperm(l,i)
40      continue
        endif

c set defaults now in case no data is read in
      jlindem1(it)=0
      jlindem2(it)=0
      cutdis(it)=0.d0
      hop(it)=0.
      sampar(it,1)=0.
      sampar(it,2)=0.
c zero pair potentials pointers
      li=index(pname(it),' ')-1
      do jt=1,ntypes
c create pointers for averages
      pairtof(jt,it)=0
      pairtof(it,jt)=0
      lj=index(pname(jt),' ')-1
      call setav(jpeij(jt,it),'V_'//pname(it)(1:li)//pname(jt)(1:lj)
     &     ,eunit,1)
      enddo

c if boson find superfluid density
         if(nspins(it).eq.0.and.hbs2m(it).gt.0.) then
             call setav(jsfd(it,1),'rs_'//pname(it)(1:li)//'_x','  ',1)
             call setav(jdf(it,1),'df_'//pname(it)(1:li)//'_x','  ',1)
             if(ndim.ge.2) then
             call setav(jsfd(it,2),'rs_'//pname(it)(1:li)//'_y','  ',1)
             call setav(jdf(it,2),'df_'//pname(it)(1:li)//'_y','  ',1)
             endif
             if(ndim.ge.3) then
             call setav(jsfd(it,3),'rs_'//pname(it)(1:li)//'_z','  ',1)
             call setav(jdf(it,3),'df_'//pname(it)(1:li)//'_z','  ',1)
             endif
          else
              do l=1,ndim
              jsfd(it,l)=0
              jdf(it,l)=0
              enddo 
          endif
c set up moving parameters
      do i=1,mnmovers
        gamma(i,it)=0.
      enddo

      if(hbs2m(it).gt.0.) then
        call setav(jimpure(it),'P_1_'//pname(it)(1:li),'  ',1)
        if(nspins(it).eq.0.or.ifixnd.eq.0) then
c bosons allow all possible moves
          do i=1,mnmovers
            gamma(i,it)=1.
          enddo
        elseif(nspins(it).gt.0.and.ifixnd.eq.1)then
c fermions allow only odd particle moves
          do i=1,mnmovers,2
            gamma(i,it)=1.
          enddo
        endif
      endif

      return
      end
