      subroutine fpdmg(r1,r2,nf,hbs2mt,dm,grad,ng,itau,itype,ifroc)
      include 'upi.cm'
      real*8 fourpi,hbs2mt,rmin,w,arg,c,cg,dx,dy,dz,dfpdmti,x
     &    ,p(mnp),dm0(mnp),r1(ndim),r2(ndim,nf),dm(nf),grad(ng,ndim)
      integer nf,ng,itau,itype,ifroc,ind(mnp),l,i
c finds a vector of free particle density matrices between r1 and r2
c and its gradient with the nearest neighbor image or table lookup
      parameter (fourpi=(4.*pi))
      include 'cpbc.cm'

      if(hbs2mt.le.0.) then
        write (*,*)' hbs2mt negative in fpdm= ',hbs2mt
        stop
      endif
      rmin=el2(1)
      do l=2,ndim
          rmin=min(rmin,el2(l))
      enddo
      w=.25/hbs2mt
      arg=rmin**2*w

      if(arg.gt.12.)  then
c take the nearest image only: accuracy= 6e-6
      c=1./(fourpi*hbs2mt)
       cg=-2*w
      if(ifroc.ne.1)cg=-cg
      if(ndim.eq.2) then
       do 24 i=1,nf
        dx=fpbc(r1(1)-r2(1,i),1)
        dy=fpbc(r1(2)-r2(2,i),2)
        dm(i)=c*exp(-w*(dx**2+dy**2))
        grad(i,1)=cg*dm(i)*dx
        grad(i,2)=cg*dm(i)*dy
24     continue
      elseif(ndim.eq.3) then
        c=sqrt(c**3)
        do 25 i=1,nf
        dx=fpbc(r1(1)-r2(1,i),1)
        dy=fpbc(r1(2)-r2(2,i),2)
        dz=fpbc(r1(3)-r2(3,i),3)
        dm(i)=c*exp(-w*(dx**2+dy**2+dz**2))
        grad(i,1)=cg*dm(i)*dx
        grad(i,2)=cg*dm(i)*dy
        grad(i,3)=cg*dm(i)*dz
25      continue
      endif

      else
c look up in precomputed tables
      do 30 l=1,ndim
      dfpdmti=(mfpdm-1)/ell(l)
c find table entry (ind) and remainder (p)
      do 31 i=1,nf
      x=dfpdmti*(fpbc(r1(l)-r2(l,i),l)+el2(l))+1
      ind(i)=x
31    p(i)=x-ind(i)
      if(l.eq.1) then
        call dtabl1(nf,ind,p,fpdmt(1,1,l,itau,itype),dm,grad,mfpdm
     +  ,dfpdmti)
      else
        call dtabl1(nf,ind,p,fpdmt(1,1,l,itau,itype),dm0,grad(1,l)
     +   ,mfpdm,dfpdmti)
        do 32 i=1,nf
32      dm(i)=dm(i)*dm0(i)
      endif
30    continue
      if(ifroc.eq.1) then
      do 36 l=1,ndim
      do 36 i=1,nf
36    grad(i,l)=grad(i,l)*dm(i)
      else
       do 50 l=1,ndim
       do 50 i=1,nf
50     grad(i,l)=-grad(i,l)*dm(i)
      endif
      endif

      return
      end
