      subroutine goffd(ip,r1,r2,v1,v2,lvl,act,g1,g2,comp)
      include 'upi.cm'
      real*8 r1(mnp),r2(mnp),g1(ndim,mnp),g2(ndim,mnp),r1i,r2i,u1,u2
     +,v1(ndim,mnp),v2(ndim,mnp),act,comp(mnc)
     +,var(mnp,mterms+1),remx(mnp),rb(mnp),dxdr(mnp)
     + ,us(mnp),uz(mnp),uq(mnp)
      integer ip,nterme,nterma,j,l,it,jt,n1,n2,idim,nfile,lvl
     +,indx(mnp),nn
c this computes the off-digonal part of the log of the density matrix
c goffd is like offd but it computes gradients and beta derivatives only.
c r1 and r2 are the old and new distances, v1 and v2 are the vectors
c and ip is the particle being moved. There are ip-1 terms added
c lvl is level and type specific energy is stored in comp
c g1 and g2 are the gradients of the action at points r1 and r2 (they are incremented).
      it=idtype(ip)
c loop over types of particles
      do jt=1,it
      nfile=pairtof(it,jt)
      comp(jt)=0.
c first last and total number of particles of this type
      n1=nfpty(jt)
      n2=min(ip-1,nlpty(jt))
      nn=n2-n1+1
      if(nfile.gt.0.and.nn.gt.0) then

        nterma=ipfilep(3,nfile)-1
        nterme=ipfilep(4,nfile)-1
        if(max(nterma,nterme).gt.0) then
          idim=ipfilep(2,nfile)
          if(lvl.gt.nlvld)stop
c set 3 variables rb var(1) and var(2)
          do j=n1,n2
c rb=q
          rb(j)=.5*(r1(j)+r2(j))
c var(1) = s: note this is can be different for PBC from offd
          var(j,1)=(v1(1,j)-v2(1,j))**2
c var(2) = z
          var(j,2)=(r1(j)-r2(j))**2
          enddo
          do 89 l=2,ndim
          do 89 j=n1,n2
c var(1) = s: note this is can be different for PBC from offd
89        var(j,1)=var(j,1)+(v1(l,j)-v2(l,j))**2

c         do j=n1,n2
c         if(rb(j).gt.4.5) then
c          var(j,2)=0.
c          var(j,1)=0.
c         endif
c         enddo

c get table indices for rb
         call tentry(rb(n1),nn,it,indx(n1),remx(n1),dxdr(n1))
c us uz and uq will hold the derivatives wrt to the variables
          call gvsum(nn,indx(n1),remx(n1),dmtable(1,1,2,lvl,1)
     &         ,var(n1,1),nterma,nterme,mnp,mntab,morder,mterms,mlevels
     &         ,idim,us(n1),uz(n1),uq(n1),dxdr(n1),rb(n1),act,comp(jt))


c now compute g1 and g2 using chain rule
      do j=n1,n2
      r1i=1/r1(j)
      r2i=1/r2(j)
      do l=1,ndim
        u1=2*us(j)*(v1(l,j)-v2(l,j))
     +          +r1i*v1(l,j)*(.5*uq(j)+2*uz(j)*(r1(j)-r2(j)))
        g1(l,ip)=g1(l,ip)+u1
        g1(l, j)=g1(l, j)-u1

        u2=-2*us(j)*(v1(l,j)-v2(l,j))
     +          +r2i*v2(l,j)*(.5*uq(j)-2*uz(j)*(r1(j)-r2(j)))
        g2(l,ip)=g2(l,ip)+u2
        g2(l, j)=g2(l, j)-u2
      enddo
      enddo

      endif
      endif
      enddo
      return
      end
