      subroutine lindem
c
c This subroutine computes the mean square displacement for the
c  current paths.  Note the use of the centering vector to correct
c  for any drift away from the lattice sites that may have occurred. 
c  The LINDEM fn command must have been issued for this function to
c  be called.
c
      include 'upi.cm'
      integer i,k,l,it
      real*8 tdis,dr,com,tcom,lin1,lin2
      include 'cpbc.cm'

      do it=1,ntypes
      if(jlindem1(it).gt.0) then

      lin1=0.d0 !corrections for com motion
      lin2=0.d0
      tdis=0.d0 !total mean squared displacement

      do l=1,ndim
        tcom=0.d0
	do k=1,nslices
        com=0.d0
      	do i=nfpty(it),nlpty(it) !sum over particles 
          dr = fpbc((r(l,i,k)-rsites(l,i)),l) ! shortest distance to lattice
          com = com+dr
          tdis=tdis+dr*dr
        enddo
! only subtract center of mass if particles are free
        if(cutdis(it).le.0.d0.and.ntypes.eq.1)then
          lin1=lin1+com**2
          tcom=tcom+com
        endif

        enddo ! end loop over slices
        if(cutdis(it).le.0.d0.and.ntypes.eq.1)then
         lin2=lin2+tcom**2
        endif
      enddo !loop over ndim

      avtemp(jlindem1(it))=avtemp(jlindem1(it))+tdis-lin1/ncomps(it)
      anorm(jlindem1(it))=anorm(jlindem1(it))+ncomps(it)*nslices
        if(cutdis(it).le.0.d0.and.ntypes.eq.1)then
      avtemp(jlindem2(it))=avtemp(jlindem2(it))+tdis
     &            - lin2/(nslices*ncomps(it))
      anorm(jlindem2(it))=anorm(jlindem2(it))+ncomps(it)*nslices
        endif

      endif
      enddo
      return
      end
