      subroutine tentry1(rl,n1,n2,nfile,indx,rem,rdxdr)
      include 'upi.cm'
      real*8 rl,rem,rdxdr,yy,aa,x,rlim
      integer indx,n1,n2,ig,j,nfile
      dimension rl(n2),indx(n2),rem(n2),rdxdr(n2)
c computes table entries for particles n1 through n2 with grid nfile
c and puts them in indx and remainder rem.  The derivative goes into rdxdr.

      ig=ipfilep(1,nfile)

      if(ig.eq.1) then
c linear grid
        do j=n1,n2
          rlim=min(rpfilep(2,nfile),max(rpfilep(1,nfile),rl(j) ))
          x= rpfilep(4,nfile)+rpfilep(3,nfile)*rlim
          indx(j)=x
          rem(j)=x-indx(j)
          rdxdr(j)=rpfilep(3,nfile)*rl(j)
        enddo

      elseif(ig.eq.2) then
c log grid
        do j=n1,n2
          rlim=min(rpfilep(2,nfile),max(rpfilep(1,nfile),rl(j) ))
          x=rpfilep(4,nfile)+rpfilep(3,nfile)*log(rlim) 
          indx(j)=x
          rem(j)=x-indx(j)
          rdxdr(j)=rpfilep(3,nfile)*rl(j)/rlim
        enddo

      elseif(ig.eq.3) then
c power grid
        do j=n1,n2
          rlim=min(rpfilep(2,nfile),max(rpfilep(1,nfile),rl(j) ))
          aa=rpfilep(3,nfile)*(rlim-rpfilep(4,nfile))
          yy=aa**rpfilep(5,nfile)
          x=rpfilep(6,nfile)+ yy
        indx(j)=x
        rem(j)=x-indx(j)
        rdxdr(j)= rl(j)*rpfilep(5,nfile)*rpfilep(3,nfile)*yy/aa
      enddo
      elseif(ig.eq.4) then
c inverse grid
        do j=n1,n2
          rlim=min(rpfilep(2,nfile),max(rpfilep(1,nfile),rl(j) ))
          aa=1./(rlim-rpfilep(5,nfile))
          x=rpfilep(4,nfile)+rpfilep(3,nfile)*aa
        indx(j)=x
        rem(j)=x-indx(j)
        rdxdr(j)=- rl(j)*aa*aa*rpfilep(3,nfile)
      enddo

      endif

      return
      end
