      program tdeg ! modified for 2d egas units Rydbergs/a
      implicit none
c generates fnpimc input for one component systems 

      integer mnp,mnkv,mnsh,ndim,mn,ncell,kmult,nppss,iseed,lvl
     &,ntail,ln,ld,j,n,lpt,ntemp,nmt,i,nparts,nxtalp,l,lf,nspins
     &,nref,nk,nvects,nexp,k,nb,np,nl,nhits,intread,ipickoff,nslices
     &,nlvls,mdim,nlamb
      real*8 tpiell,rkcomp,rk,u,wsites,expon,cexpon,charge,rho
     &,hbs2m,tlow,cutr,rs,accuracy,alpha,pot0,vol,rnn,enorm
     &,e2,vn,sang,vtail,ptail,temp,tau,beta,del,xx,ranf,cutk
     &,cc,zz,gr,gr0,theta,q,arg,pi,tn,s,vself,gamma,rlread,tslice
     &,ti,vimage,sumv

c Note-mdim no longer has to be changed.
      parameter (mnp=250,mnkv=1000,mnsh=200,mdim=3,mn=10)
      parameter (pi=3.14159265358979)
      dimension tpiell(mdim),ncell(3),rkcomp(mdim,mnkv),rk(mnsh)
     +,kmult(0:mnsh),u(0:mnsh,3),nppss(2),wsites(mdim,mnp),iseed(2)
     +,expon(20),cexpon(20)
      character qid*8,filen*24,ptype*5,dmfile*10,p(mn)*28,pott*10

      real*8 ell(3),el2(3)

      iseed(2)=111
      iseed(1)=0
      call iranset(iseed)
      ntail=-1
      charge=0.

      write (*,*) 'input name of run'
      read (*,55) qid
55    format(a)
      ln=index(qid//' ',' ')-1
      open(1,file=qid(1:ln)//'.sy',status='unknown')
c auxillary file
      open(7,file=qid(1:ln)//'.os',status='unknown')
c input name of density matrix file
      write (*,*) 'input dm file '
      read (*,55) dmfile
      ld=index(dmfile,' ')-1
      open(8,file=dmfile(1:ld)//'.dm')
      rho=0.

1     j=ipickoff(8,p,n,mn)

      if(p(1).eq.'UNITS') then
       call echo(1,p,n)

      elseif(p(1).eq.'TYPE') then
c particle label
      ptype=p(2)
      lpt=index(ptype,' ')-1
      hbs2m=rlread(p(3))

      elseif(p(1).eq.'SQUARER') then
c read squaring parameters
      tlow=rlread(p(2))
      ntemp=intread(p(3))
      ndim=intread(p(4))
      if(ndim.ne.2)stop
      nmt=intread(p(5))

      elseif(p(1).eq.'POT')then
c look at potential
      cutr=rlread(p(3))
      pott=p(2)

        if(p(2).eq.'SCCOUL') then
         rs=rlread(p(5))
         rho=3/(4*pi*rs**3)

        elseif(p(2).eq.'COUL') then
         charge=rlread(p(4))
         accuracy=rlread(p(5))
         alpha=-.5*log(accuracy*cutr/abs(charge))/cutr**2

        elseif(p(2).eq.'COULOPT') then
         charge=rlread(p(4))
         nlamb=intread(p(6))
         do l=1,ndim  
           if(l+6.le.n) then
            ell(l)=rlread(p(l+6))
           else
            ell(l)=ell(l-1)
           endif
         enddo

        endif

      elseif(p(1).eq.'POTTAIL') then
       pot0=rlread(p(2))
       ntail=intread(p(3))
       if(ntail.gt.0)stop

      elseif(p(1).eq.'VIMAGE') then
        vimage=rlread(p(2))

      elseif(p(1).eq.'RANK') then
       go to 2
      endif
      go to 1

2     continue
c read number of particles
      write (*,*) 'input: nparts '
      read (*,*) nparts
      if(nparts.gt.mnp) stop
      if(rho.eq.0) then
          write (*,*)' input rs '
          read (*,*) rs
      endif
      rho=1.d0/pi
      write (7,*)  'rs',rs,'rho = ',rho
      vol=nparts/rho
c read input crystal structure
      write (*,*) 'input crystal number of unit cells in each direction'
      write (*,*) 'crystal:1=sc,2=bcc,3=hcp,4=fcc(3d),3=triangular(2d)'
      read (*,*) nxtalp,(ncell(l),l=1,ndim)
      call sites(1,wsites,nparts,ndim,nxtalp,vol,ncell,ell,rnn,mdim)

c energy normalization
      enorm=nparts
      write (1,89)' ENORM ',enorm
89    format(a10,e17.8)

c cutoff radial tables at 1/2 the smallest box dimension
      e2=.5*ell(1)
      do 10 l=1,ndim
      tpiell(l)=2*pi/ell(l)
10    e2=min(e2,.5*ell(l))
      if(e2.lt.cutr)then
        write (*,*) ' potential sticks out of box ',cutr,e2
c       stop
      endif
      write (1,88) (ell(l),l=1,ndim)
88    format(' BOXSIZE',3e18.10)


      write (*,*) ' possible fits=',nmt
      write (*,*) ' possible tslice ',(tlow*2**(l-1),l=1,ntemp)
      write (*,*) ' input physical temperature, tslice '
      read (*,*) temp,tau
      tslice=0.
      do l=1,ntemp
      if(abs(tau/(tlow*2**(l-1))-1.).lt..001) then
        tslice=tlow*2**(l-1)
        nlvls=l
      endif
      enddo

      if(tslice.eq.0.)stop
      nslices=tslice/temp+.001
      beta=nslices/tslice
      write (*,*)' nslices = ',nslices,' temp ',1./beta
      write (1,89)' BETA ',beta
      write (1,*)' NSLICES ',nslices

      do 20 l=1,ndim
      el2(l)=.5*ell(l)
20    tpiell(l)=2*pi/ell(l)

      filen=qid(1:ln)//'.'//ptype(1:lpt)//'.ic'
      lf=index(filen,' ')-1
c add some random displacements
      write (*,*) ' enter initial random dispacements '
      read (*,*) del
      if(del.gt.0.) then
         do 555 l=1,ndim
         del=.01*ell(l)
             do 555 i=1,nparts
             xx=wsites(l,i)+del*(ranf()-.5)
             if(xx.gt.el2(l))  xx=xx-ell(l)
             if(xx.lt.-el2(l)) xx=xx+ell(l)
555   wsites(l,i)=xx
      endif
c write out coordinates
      call writecon(wsites,ndim,nparts,ell,filen,mdim)

      write (*,*) 'input: nspins nppss '
      read (*,*) nspins,(nppss(j),j=1,nspins)

      if(nspins.eq.1) then
      write (1,71)ptype,hbs2m,nspins,nparts,(nppss(i),i=1,nspins),filen
71     format('TYPE ',a3,e17.9,3i5,' ',a14)
      elseif(nspins.eq.2) then
      write (1,72)ptype,hbs2m,nspins,nparts,(nppss(i),i=1,nspins),filen
72     format('TYPE ',a3,e17.9,4i5,' ',a14)
      elseif(nspins.eq.0) then
      write (1,73)ptype,hbs2m,nspins,nparts,(nppss(i),i=1,nspins),filen
73     format('TYPE ',a3,e17.9,2i5,' ',a14)
      endif

      write (1,*) 'POT PAIR  ',ptype,' ',ptype,' '
     +   ,dmfile(1:ld)//'.dm' 
      write (1,*) ' GAMMA 3 ',ptype,' ',float(nparts)
      write (1,*) 'FREESAMP'
c     write (1,*) 'DISPLACE ',ptype,' ',0.5

      if(nspins.gt.0) then
c     write (*,*) 'input nref (0 1 or 2)'
c     read (*,*) nref
      nref=2
      write (1,*) 'NREF ',nref
      endif

c if construct the long ranged potential
      if(charge.ne.0) then 

       if(pott.eq.'COUL') then
           cutk=2*cutr*alpha
           call shells(ndim,tpiell,cutk,nk,rkcomp,rk(1),kmult
     +        ,nvects,mnkv,mnsh,mdim)
           nexp=1
           cc=charge*pi**(.5*ndim)/(vol*gamma(.5*nexp))
           zz=.5*(ndim-nexp)
           u(0,1)= -cc/(zz*alpha**zz)
           vself=-charge*alpha**(.5*nexp)/(nexp*gamma(.5*nexp))
           vn=.5*rho*sang(ndim)*cutr**ndim*pot0/float(ndim)
           vtail=vself+vn +.5*nparts*u(0,1)
           do k=1,nk
               call gammi(gr,zz,rk(k)**2/(4*alpha),gr0)
c this is the potential
               u(k,1)=cc*gr*(.5*rk(k))**(-ndim+nexp)
           enddo

       elseif(pott.eq.'COULOPT') then
           cutk = 6*tpiell(1)
           call shells(ndim,tpiell,cutk,nk,rkcomp,rk(1),kmult
     +        ,nvects,mnkv,mnsh,mdim)
           nk=nlamb
           cutk=rk(nlamb)*1.001
           open(4,file=dmfile(1:ld)//'.vk',status='old')
           call checkrnk(4,1,nk+1)
           call findbegn(4)
           read (4,*) (u(k,1),k=0,nk)
           vtail=vimage+.5*nparts*u(0,1)
       endif

       write (*,*)' number of k-vectors ',nk,nvects
c Write out long range potential, action and beta derivative
       write (1,*)'POT EWALD ',cutk,' ',qid(1:ln)//'.lr'
       open(2,file=qid(1:ln)//'.lr',status='unknown')
c write header
       write (2,*)'RANK 5 ',nk,' 1 1 3 ',nlvls
       write (2,*)'BEGIN k-space action'
       sumv=0.

       do lvl=1,nlvls
       ti=2**(lvl-1)/tslice
       do k=1,nk
c now rpa for the density matrix and its time derivative
       arg=1.+2*u(k,1)*nparts/(hbs2m*rk(k)**2)
       theta=.5*rk(k)**2*hbs2m*ti
       if(arg.le.0)then
         q=sqrt(-arg)
         if(q*theta.ge..5*pi)stop
         tn=tan(theta*q)
         s=q*(1-q*tn)/(q+tn)
       elseif(arg.eq.0)then
         s=1./(1+theta)
       elseif(arg.gt.0)then
         q=sqrt(arg)
         tn=tanh(theta*q)
         s=q*(1+q*tn)/(q+tn)
       endif

c u(k,2) is the action
       u(k,2)=(-1.+s)/float(nparts)
c u(k,3) is the beta derivative of the action - the potential
       u(k,3)=-hbs2m*rk(k)**2*u(k,2)*(1+.5*nparts*u(k,2))
       if(lvl.eq.1)sumv=sumv+(kmult(k)-kmult(k-1))*(rk(k)*u(k,2))**2
       enddo

       do i=1,3
       write (2,*)(u(k,i),k=1,nk)
       enddo
       enddo
       close(2)

c kinetic tail correction
!     sumv=-sumv*hbs2m/(nparts-1.)
!     write (*,*)' udot0 = ', sumv
!     vtail = vtail+sumv
c tail correction to total potential/particle
       write (1,89)' VTAIL ',vtail
!      ptail=rho*vtail
!      write (1,89)' PTAIL ',ptail

      else

c define cutk just to see s(k) for short range potential
!     cutk=3.1*(nparts/vol)**(1./ndim)
!     write (1,89)' CUTK ',cutk
      endif

c now some input for the run
      write (1,*)'RESTART'

      write (*,*)' input blocks passes, levels for omove '
      read (*,*) nb,np,nl
      if(nb.gt.0)write (1,*) 'OMOVE ',nb,' ',np,' ',nl
!     write (*,*)' input blocks, passes, levels, hitsfor select '
!     read (*,*) nb,np,nl,nhits
!     if(nb.gt.0)write (1,*) 'SELECT ',nb,' ',np,' ',nl,' ',nhits
      end 
