      program dropset
      include 'mach.p'
c generates upi input for one component systems 
c version of 4/94, D. Ceperley UIUC

      integer mnp,mdim,mn
      parameter (mnp=500,mdim=3,mn=10)
      integer ndim,ncell(3),nppss(2),iseed(2),new
     &,ln,ld,j,n,lpt,ntemp,nmt,i,nparts,nxtalp,l,lf,nspins
     &,nref,nb,np,nl,nhits,intread,ipickoff,nslices,nlvls
      real*8 wsites(mdim,mnp),rho,hbs2m,tlow,cutr,vol,rnn,enorm
     &,temp,tau,beta,del,xx,ranf,rlread,tslice,ell(3),rsq
      character qid*8,filen*24,ptype*5,dmfile*10,p(mn)*28

      iseed(2)=111
      iseed(1)=0
      call iranset(iseed)

      write (*,*) 'input name of run'
      read (*,55) qid
55    format(a)
      ln=index(qid//' ',' ')-1
      open(1,file=qid(1:ln)//'.sy',status='unknown')
c auxillary file
      open(7,file=qid(1:ln)//'.os',status='unknown')
c input name of density matrix file
      write (*,*) 'input dm file '
      read (*,55) dmfile
      ld=index(dmfile,' ')-1
      open(8,file=dmfile(1:ld)//'.dm')

1     j=ipickoff(8,p,n,mn)

      if(p(1).eq.'UNITS') then
       call echo(1,p,n)

      elseif(p(1).eq.'TYPE') then
c particle label
      ptype=p(2)
      lpt=index(ptype,' ')-1
      hbs2m=rlread(p(3))

      elseif(p(1).eq.'SQUARER') then
c read squaring parameters
      tlow=rlread(p(2))
      ntemp=intread(p(3))
      ndim=intread(p(4))
      if(ndim.lt.2.or.ndim.gt.3)stop
      nmt=intread(p(5))

      elseif(p(1).eq.'RANK') then
       go to 2
      endif
      go to 1

2     continue

c read input crystal structure
      write (*,*) 'input crystal number of unit cells in each direction'
      write (*,*) 'crystal:1=sc,2=bcc,3=hcp,4=fcc(3d),3=triangular(2d)'
      read (*,*) nxtalp,(ncell(l),l=1,ndim)
      nparts=nxtalp*ncell(1)*ncell(2)*ncell(3)

      if(nparts.gt.mnp) stop
      rho=.018
      vol=nparts/rho
c generate lattice-then throw away points too far away
      call sites(1,wsites,nparts,ndim,nxtalp,vol,ncell,ell,rnn,mdim)
      write (*,*)' number of trial sites ',nparts,ell(1)/2
     +   ,' input cutr '
      read (*,*) cutr
      new=0
      do i=1,nparts
      rsq=0.
       do l=1,ndim
         rsq=rsq+wsites(l,i)**2
       enddo
       rsq=sqrt(rsq)
       if(rsq.gt.1.e-5*cutr.and.rsq.lt.cutr) then
         new=new+1
         do l=1,ndim
           wsites(l,new)=wsites(l,i)
         enddo
       endif
      enddo
      write (*,*)' final number of particles ',new
      nparts=new

c energy normalization
      enorm=nparts
      write (1,89)' ENORM ',enorm
89    format(a10,e17.8)

      do l=1,ndim
      ell(l)=4*cutr
      enddo
      write (1,88) (ell(l),l=1,ndim)
88    format(' BOXSIZE',3e18.10)


      write (*,*) ' possible fits=',nmt
      write (*,*) ' possible tslice ',(tlow*2**(l-1),l=1,ntemp)
      write (*,*) ' input physical temperature, tslice '
      read (*,*) temp,tau
      tslice=0.
      do l=1,ntemp
      if(abs(tau/(tlow*2**(l-1))-1.).lt..001) then
        tslice=tlow*2**(l-1)
        nlvls=l
      endif
      enddo

      if(tslice.eq.0.)stop
      nslices=tslice/temp+.001
      beta=nslices/tslice
      write (*,*)' nslices = ',nslices,' temp ',1./beta
      write (1,89)' BETA ',beta
      write (1,*)' NSLICES ',nslices

      filen=qid(1:ln)//'.'//ptype(1:lpt)//'.ic'
      lf=index(filen,' ')-1
c add some random displacements
      write (*,*) ' enter initial random dispacements '
      read (*,*) del
      if(del.gt.0.) then
         do 555 l=1,ndim
             do 555 i=1,nparts
             xx=wsites(l,i)+del*(ranf()-.5)
555   wsites(l,i)=xx
      endif

c write out coordinates
      call writecon(wsites,ndim,nparts,ell,filen,mdim)

      write (*,*) 'input: nspins nppss '
      read (*,*) nspins,(nppss(j),j=1,nspins)

      if(nspins.eq.1) then
      write (1,71)ptype,hbs2m,nspins,nparts,(nppss(i),i=1,nspins),filen
71     format('TYPE ',a3,e17.9,3i5,' ',a14)
      elseif(nspins.eq.2) then
      write (1,72)ptype,hbs2m,nspins,nparts,(nppss(i),i=1,nspins),filen
72     format('TYPE ',a3,e17.9,4i5,' ',a14)
      elseif(nspins.eq.0) then
      write (1,73)ptype,hbs2m,nspins,nparts,(nppss(i),i=1,nspins),filen
73     format('TYPE ',a3,e17.9,2i5,' ',a14)
      endif

      write (1,*) 'POT PAIR  ',ptype,' ',ptype,' '
     +   ,dmfile(1:ld)//'.dm' 
      write (1,*) ' GAMMA 3 ',ptype,' ',float(nparts)
      write (1,*) 'FREESAMP'
      write (1,*) 'DISPLACE ',ptype,' ',0.5

      if(nspins.gt.0) then
      nref=2
      write (1,*) 'NREF ',nref
      endif

c now some input for the run
      write (1,*)'RESTART'

      write (*,*)' input blocks passes, levels for omove '
      read (*,*) nb,np,nl
      if(nb.gt.0)write (1,*) 'OMOVE ',nb,' ',np,' ',nl
      write (*,*)' input blocks, passes, levels, hitsfor select '
      read (*,*) nb,np,nl,nhits
      if(nb.gt.0)write (1,*) 'SELECT ',nb,' ',np,' ',nl,' ',nhits
      end 
